/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/break.h		$Revision: $
 * 
 *  Purpose:
 *	HP Precision Architecture Break Instruction
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/break.h
 *	/usr/conf/pa/break.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif

#ifndef _MACHINE_BREAK_INCLUDED
#define _MACHINE_BREAK_INCLUDED

#ifdef __hp9000s800

#ifndef	LOCORE
struct break_inst {
	unsigned bi_opcode:6;
	unsigned bi_i2:13;
	unsigned bi_extension:8;
	unsigned bi_i1:5;
};
#endif	/* not LOCORE */

/*
 * Immediate Field Reference Macros
 */
#define	biopcode(x)	(((struct break_inst *)&(x))->bi_opcode)
#define	biextension(x)	(((struct break_inst *)&(x))->bi_extension)
#define	bi1(x)		(((struct break_inst *)&(x))->bi_i1)
#define	bi2(x)		(((struct break_inst *)&(x))->bi_i2)

#define	BIOPCODE	0
#define	BIEXTENSION	0

/*
 *      Test If Specific Break Instruction
 * e.g. isbreak(inst,BI1_AZURE,BI2_AZURE_EXECT)
 */
#define	isbreak(i,x,y)	((bi1(i)==(x))&&(bi2(i)==(y)))


/*
 * Break Instruction I1 Field
 *     (Primary Opcodes)
 */
#define BI1_STOP        0
#define BI1_RDCHAR      1
#define BI1_WRTCHAR     2
#define BI1_SYSCALL     3
#define BI1_AZURE       4
#define BI1_ICS         5
#define BI1_ICA         6
#define BI1_AC_START    7
#define BI1_AC_STOP     8
#define BI1_PF_RDBSTOP	9
#define BI1_STEP_BRK	10
#define BI1_DLKM_BRK    11 		
#define BI1_KGDB	12


/*
 *     RDB System Calls
 * Break Instruction I2 Field
 *     for BI1_SYSCALL
 */
#define	BI2_SYSCALL_READ	0
#define	BI2_SYSCALL_WRITE	1
#define	BI2_SYSCALL_CLOSE	2
#define	BI2_SYSCALL_CREAT	3
#define	BI2_SYSCALL_OPEN	4
#define	BI2_SYSCALL_LSEEK	5
#define	BI2_SYSCALL_CHDIR	6
#define	BI2_SYSCALL_CHMOD	7
#define	BI2_SYSCALL_DUP		8
#define	BI2_SYSCALL_LINK	9
#define	BI2_SYSCALL_UNLINK	10
#define	BI2_SYSCALL_ACCESS	11
#define	BI2_SYSCALL_TIME	12
#define	BI2_SYSCALL_UMASK	13
#define	BI2_SYSCALL_HALT	14

/*
 *	KGDB Breaks
 * Break Instruction I2 Field
 *     for BI1_KGDB
 */
#define BI2_KGDB_GDB          5
#define BI2_KGDB              6


/*
 *     Azure Breaks
 * Break Instruction I2 Field
 *     for BI1_AZURE
 */
#define	BI2_AZURE_SSTEP1		0
#define	BI2_AZURE_SSTEP2		1
#define	BI2_AZURE_SSTEPSYSRET		2
#define	BI2_AZURE_SSTEPSIGSYSRET	3
#define	BI2_AZURE_SSTEPSIGTRAPRET	4
#define	BI2_AZURE_SSTEPSENDSIG		5
#define	BI2_AZURE_ABORT			6
#define	BI2_AZURE_EXECT			7
#define	BI2_AZURE_BPT			8
#define	BI2_AZURE_SIGRETURN		9
#define	BI2_AZURE_EXIT			10
#define	BI2_AZURE_REBOOT		11
#define	BI2_AZURE_LONGJMP		12
#define	BI2_AZURE_CRT0			13

/*
 *     ICS Breaks
 * Break Instruction I2 Field
 *     for BI1_ICS
 */
#define BI2_ICS_PDC_CALL        1

#endif /* __hp9000s800 */
#endif /* _MACHINE_BREAK_INCLUDED */
