/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/clock/clock.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/clock.h
 *	/usr/conf/pa/clock.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif

#ifndef _MACHINE_CLOCK_INCLUDED /* allow multiple inclusions */
#define _MACHINE_CLOCK_INCLUDED

#include <sys/stdsyms.h>

#define	SECDAY		(24*60*60)		/* seconds per day */
#define	SECYR		(365*SECDAY)		/* per common year */
#define	dysize(A) 	(((A)%4)? 365: 366)	/* days per year   */


/*
 * For the MP clock resync state machine
 */
typedef enum __itmr_sync_handshake_t {
	M_WAITING_FOR_NM = 1,
	NM_CHECK_IN,
	READING,
	DONE_READING
} itmr_sync_handshake_t;


/*
 * Performance shortcut for ms_gettimeofday() and any other callers who
 * wish to trade off a bit of code space for speed.
 */
#define READ_ADJUSTED_ITMR(reg_var)	(uniprocessor ? \
					 (_MFCTL(CR_IT, reg_var), reg_var) : \
					 (reg_var = read_adjusted_itmr()))

/*
 * For these types, 'adj' refers to ADJtime, not to monarch vs. serf
 * CR16 adjustments (read_adjusted_itmr())
 */
typedef unsigned long	RawCR16Count_t;
typedef unsigned long	AdjCR16Count_t;
typedef long		RawCR16Delta_t;
typedef long		AdjCR16Delta_t;
typedef long		AdjuSecDelta_t;

/* External variable declarations */
   extern RawCR16Count_t ms_last_current_count;
   extern RawCR16Count_t last_time_itval;

#ifndef _STRUCT_TIMEVAL
struct timeval;
#endif

/*
 * Prototypes
 */

extern struct timeval	ms_gettimeofday __((void));
extern void		log_ticks __((long ticks));
extern void             clock_int __((int int_bit, struct save_state *ssp));
extern struct timeval	get_time __((struct timeval *time_var));
extern void		startrtclock __((void));
extern void		start_itimer __((void));
extern void		inittodr __((time_t base));
extern int		resettodr __((struct timeval *tv));
extern void		change_time __((struct timeval *t));
extern int		store_time_to_todr __((struct timeval *optional_new_timevalp));
extern void		load_os_time_from_todr __((void));
extern RawCR16Count_t	read_adjusted_itmr __((void));
extern void		nm_itmr_sync __((void));
extern void		do_initial_nm_itmr_sync __((void));
extern void		monarch_pfail_sync_release __((void));
extern void		m_prepare_for_forced_sync __((int nm_proc_idx));
extern void		m_itmr_sync __((int nm_proc_idx));
extern void		log_bad_rendezvous __((int nm_proc_idx));
extern int		set_it __((u_int *elapsed_usec));


#endif /* _MACHINE_CLOCK_INCLUDED */
