/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/crash.h
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/crash.h
 *	/usr/conf/pa/crash.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#define CT_NORMAL	0
#define CT_PANIC	1
#define CT_TOC  	2
#define CT_HPMC 	3

#define TOC_MAGIC 0x31546F63

#if	(MAX_PROCS > 128)
MAX_PROCS has larger value than kernel currently supports(128) -- increase
CRASH_TABLE_SIZE and CRASH_EVENT_TABLE_SIZE
#endif	/* (MAX_PROCS > 128) */

#ifdef	__LP64__			/* MAX_PROCS == 128 for LP64	*/
#define CRASH_TABLE_SIZE	8192
#define CRASH_EVENT_TABLE_SIZE	8192
#else	/* !__LP64__ */			/* MAX_PROCS == 16 for 32bit	*/
#define CRASH_TABLE_SIZE	2048
#define CRASH_EVENT_TABLE_SIZE	2048
#endif	/* __LP64__ */

#ifndef LOCORE
typedef struct crash_proc_table_struct {
	ulong_t		cpt_hpa;
	struct mpinfo  *cpt_ppdp;
	caddr_t		cpt_pdc_vector;
	struct rpb     *cpt_hpmc_savestate;
	struct rpb     *cpt_toc_savestate;
	int		cpt_hpmc_count;
	int		cpt_toc_count;
	int		cpt_state_saved;
} crash_proc_t;

typedef struct crash_event_table_struct {
	int		cet_reserved;
	ulong_t		cet_hpa;
	int		cet_event;
	struct rpb     *cet_savestate;
	long long	cet_start_itmr;
	long long	cet_cur_itmr;
} crash_event_t;
#endif  /* LOCORE */
