/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/vm/dmem.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this 
 *	  file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/dmem.h
 *	/usr/conf/pa/dmem.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
 */

/*
 ***************************************************************************
 * DMEM_REVISIT
 * 	Remove all lines surrounded by _OLD_DMEM_DRIVER_SUPPORTED 
 *	when the old driver's API is obsoleted. 
 ***************************************************************************
 */

#define _OLD_DMEM_DRIVER_SUPPORTED	/* we are currently supporting it */


#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif /* __NO_PA_HDRS */


#ifndef _DMEM_H_INCLUDED
#define _DMEM_H_INCLUDED


#ifdef  _OLD_DMEM_DRIVER_SUPPORTED

/*
 * Ioctl functions supported by the dmem driver
 *
 */
#define DMEM_LOCK	_IOW('m', 1, int)
#define DMEM_LOCKWAIT	_IOW('m', 2, int)
#define DMEM_UNLOCK	_IOW('m', 3, int)
#define DMEM_SETBAD	_IOW('m', 4, int)
#define DMEM_SETGOOD	_IOW('m', 5, int)
#define DMEM_GETSTATUS	_IOWR('m', 6, struct dmem_status)
#define DMEM_IOMODE	_IO('m', 7)
#define DMEM_MEMMODE	_IO('m', 8)
#define DMEM_GETLPMC	_IOWR('m', 9, struct dmem_lpmc_type)
#define DMEM_CLEARLPMC	_IOW('m', 10, int)
#define DMEM_LOCK_USER	_IOW('m', 11, int)
#define DMEM_SCRUB_RW	_IOW('m', 12, int)
#define DMEM_SCRUB_READ	_IOW('m', 13, int)

/*
 * Structure for obtaining the status of a memory page
 */
struct dmem_status {
	int	dmem_page;	/* input: page number, rest is output */
	int	dmem_locked;	/* true if page is locked */
	int	dmem_bad;	/* true if page is marked bad */
	int	dmem_busy;	/* true if page is busy */
	int	dmem_type;	/* The type of the page */
};

#endif /* _OLD_DMEM_DRIVER_SUPPORTED */



/*
 * Ioctl functions supported by the [multi-threaded] dmem driver
 */
#define DMEM_MT_LOCK		_IOW('m', 21, dmem_generic_t)
#define DMEM_MT_LOCKWAIT	_IOW('m', 22, dmem_generic_t)
#define DMEM_MT_UNLOCK		_IOW('m', 23, dmem_generic_t)
#define DMEM_MT_SETBAD		_IOW('m', 24, dmem_generic_t)
#define DMEM_MT_SETGOOD		_IOW('m', 25, dmem_generic_t)
#define DMEM_MT_GETSTATUS	_IOWR('m', 26, dmem_generic_t)
#define DMEM_MT_IOMODE		_IOW('m', 27, dmem_generic_t)
#define DMEM_MT_MEMMODE		_IOW('m', 28, dmem_generic_t)
#define DMEM_MT_GETLPMC		_IOWR('m', 29, dmem_generic_t)
#define DMEM_MT_CLEARLPMC	_IOW('m', 30, dmem_generic_t)
#define DMEM_MT_LOCK_USER	_IOW('m', 31, dmem_generic_t)
#define DMEM_MT_SCRUB_RW	_IOW('m', 32, dmem_generic_t)
#define DMEM_MT_SCRUB_READ	_IOW('m', 33, dmem_generic_t)
#define DMEM_MT_READ		_IOWR('m', 34, dmem_generic_t)
#define DMEM_MT_WRITE		_IOW('m', 35, dmem_generic_t)


/*
 * DMEM_GETSTATUS will return the following in `dmem_type,' which 
 * describes how the operating system views the page you specified.
 */
#define DMEM_RESERVED	1	/* The system will never let you have it. */
#define DMEM_AVAILABLE	2	/* The page is available for testing. */
#define DMEM_BUSY	3	/* The page is busy, but available.  Use */
				/* DMEM_LOCKWAIT to get the page. */
#define DMEM_HOLE	4	/* The page number has no physical
				   manifestation. */
#define DMEM_REMOVED	5	/* The page has been removed from pfdat */


/*
 * status of a particular logging structure
 */
#define DMEM_LPMC_FREE	0
#define DMEM_LPMC_USED	1


/*
 * Depth of the logging array. Same as MAX_LPMC_SLOTS in trap.c
 */
#define MAX_DMEM_LOG	(MAX_PROCS * 2) 


#define DMEM_MAX_CHANNELS	512	/* max no of channels per proc */
#define DMEM_MAX_CELLS		32	/* max cells per channel */




struct dmem_viper_type {
	unsigned int	status;    /* following fields from LPMC handler */
	unsigned int	data_zero;
	unsigned int	data_one;
	unsigned int	check_byte;
	unsigned int	error_addr;
};


struct dmem_bush_type {
	unsigned int	status_A;
	unsigned int	addr_A;
	unsigned int	synd_A;
	unsigned int	status_B;
	unsigned int	addr_B;
	unsigned int	synd_B;
};


struct dmem_lpmc_type   {
	unsigned int	slot_status;  /* valid info in this slot? */
	unsigned int	slot_num;
	union {
		struct dmem_viper_type	viper;
		struct dmem_bush_type	bush;
	} d;
};

#define _DMEMLPMCTYPE_T


/*
 * Structure for obtaining the status of a memory page
 * [used by the multi-threaded dmem driver]
 */
struct dmem_mt_status {
	uint64_t	dmem_page;	/* i/p: page number, rest is output */
	int		dmem_locked;	/* true if page is locked */
	int		dmem_bad;	/* true if page is marked bad */
	int		dmem_busy;	/* true if page is busy */
	int		dmem_type;	/* The type of the page */
};


/*
 * Structure used by DMEM_MT_READ and DMEM_MT_WRITE functions
 */
struct dmem_rw_type {
	uint64_t	offset;		/* offset in IO/MEMORY space */
	uint64_t	cbuf;		/* addr of data buffer */
	uint64_t	count;		/* size of buffer (in bytes) */
};


/*
 * Generic data type for all dmem ioctl calls (of type: DMEM_MT_xyz)
 */
typedef struct {
	int				channel;	/* channel id */

	union {
		uint64_t		page;
		struct dmem_mt_status	status;
		struct dmem_lpmc_type	lpmc_type;
		struct dmem_rw_type	rw_type;
	} data;

} dmem_generic_t;



#ifdef _KERNEL

#include <sys/stdsyms.h>
#include <sys/types.h>
#include <sys/spinlock.h>


/*
 **************************************************************************
 * Defines used by the dmem driver
 **************************************************************************
 */

#define IO_ADDR_MODE	0
#define MEM_ADDR_MODE	1

#define DMEM_FREE_PAGE	0
#define DMEM_USER_PAGE	1

#define DMEM_EMPTY	0

#define DMEM_NO_SLEEP	0
#define DMEM_SLEEP	1

#define DMEM_READ	0
#define DMEM_RDWR	1


/*
 **************************************************************************
 * Type/structure definitions used by the dmem driver
 **************************************************************************
 */

/*
 * Definition of a cell
 */
typedef struct dmem_cell {
	physpfn_t	page_locked;		/* pfn of locked page */
	physpfn_t	base_pfn;		/* base pfn of (super)page */
	pgcnt_t		npfns;			/* # of pfns in (super)page */
	int		page_type;		/* free/user page */
} dmem_cell_t;


/*
 * Definition of a directory entry
 */
typedef struct dmem_dentry {
	int			channel;		/* channel id */
	int			in_use;			/* entry free/busy */
	int			addr_mode;		/* memory/io mode */
	int			cells_used;		/* num cells used */
	dmem_cell_t		cell[DMEM_MAX_CELLS];	/* locked page info */
	struct dmem_dentry	*prev;			/* back link */
	struct dmem_dentry	*next;			/* forw link */

	struct kthread		*kthread_p;		/* current locker */
} dmem_dentry_t;


/*
 * Definition of a processes' dmem info structure
 */
struct dmem_pinfo {
	lock_t			lock;			/* dir lock */
	dmem_dentry_t		*dentry;		/* ptr to dir entries */
};
typedef struct dmem_pinfo	dmem_pinfo_t;


/*
 **************************************************************************
 * Locking macros used by the dmem driver
 **************************************************************************
 */

/*
 * Macros to operate on a [dmem related] directory lock
 */
#define DMEM_LOCK_DIRECTORY(dmem_p)		spinlock(&((dmem_p)->lock))
#define DMEM_UNLOCK_DIRECTORY(dmem_p)		spinunlock(&((dmem_p)->lock))
#define OWNS_DMEM_DIRECTORY_LOCK(dmem_p)	T_SPINLOCK(&((dmem_p)->lock))


/*
 * Macros to operate on a [dmem related] channel lock
 */
#define DMEM_LOCK_CHANNEL(dentry)		((dentry)->in_use = 1)
#define DMEM_FORCE_LOCK_CHANNEL(dentry)		((dentry)->in_use = 1)
#define DMEM_UNLOCK_CHANNEL(dentry)		((dentry)->in_use = 0)
#define DMEM_CHANNEL_LOCKED(dentry)		((dentry)->in_use ? 1 : 0)

/*
 **************************************************************************
 * Other utility macros used by the dmem driver
 **************************************************************************
 */

/*
 * Dmem page to logical page
 */
#define DMEMPTOP(x)							\
	((cpu_version == CPU_PA_RISC1_0)				\
		? ((x) * NBPG_PA83 / NBPG)				\
		: (((cpu_version == CPU_PA_RISC1_1) ||			\
		    (cpu_version == CPU_PA_RISC2_0))			\
			? (x)						\
			: (panic("dmem.h: PA-RISC type is unknown."),0)))

/*
 * Macro to determine whether a page is valid
 */
#define PAGEOK(pg)	PFDAT_VALID((pg))


/*
 **************************************************************************
 * Global variables
 **************************************************************************
 */
extern int	cpu_version;

/*******************************************************************
 * DMEM_REVISIT:  Remove this extern definition and all references
 *		  to it when the old driver's API is made obsolete.
 *******************************************************************/
extern int	_mt_dmem_driver_enabled;


/*
 **************************************************************************
 * Function prototypes for routines exported by dmem.c
 **************************************************************************
 */
extern void	dmem_install __((void));
extern int	dmem_open __((dev_t));
extern int	dmem_close __((dev_t));
extern int	dmem_ioctl __((dev_t, int, caddr_t, int));
extern void	dmem_closeall __((void));

#ifdef  _OLD_DMEM_DRIVER_SUPPORTED
struct uio;
int		dmem_read(dev_t dev, struct uio *uio);
int		dmem_write(dev_t dev, struct uio *uio);
#endif /*  _OLD_DMEM_DRIVER_SUPPORTED */


#endif /* _KERNEL */

#endif /* _DMEM_H_INCLUDED */
