/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/vm/hdl_vas.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/hdl_vas.h
 *	/usr/conf/pa/hdl_vas.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef _HDL_VAS_INCLUDED
#define _HDL_VAS_INCLUDED

struct	hdlvas {
	space_t hdl_textsid;    /* Text Space id for shared use. */
				/* Need for multithreaded apps. */
	prot_t  hdl_textpid;    /* Text Protection id for shared use */
				/* Need for multithreaded apps. */
	space_t	hdl_datasid;	/* Data Space id for shared use by pregions. */
	prot_t hdl_datapid;	/* Data Protection id for shared use by */
				/* pregions.  */
	ushort v_hdlflags;      /* Flags to identify specific hdl details */
				/* about this address space.             */
};

/*
 * Values for v_hdlflags
 */
#define VHDL_SID_ALLOC		0x0001	/* hdl_datasid is valid */
#define VHDL_PRIVATE_TEXT	0x0002	/* A private text pregion exists. */
#define VHDL_PROTID_ALLOC	0x0004	/* hdl_datapid is valid */

/*
 * Macros to set/clear an HDL flag for this address space.
 */

#define  HDL_VA_FLAG_ON(vas,flag) (vas->va_hdl.v_hdlflags |= (flag))
#define  HDL_VA_FLAG_OFF(vas,flag) (vas->va_hdl.v_hdlflags &= (~flag))

/*
 * Interfaces to determine "quadrant" locations given a particular vas.  These
 * interfaces are needed becasue "spreg" can't be used during boot(spreg 
 * references u.u_procp) as well as in hdl_policy.c where u.u_procp may not be
 * the address we are attaching to(like during exec).
 */
#ifdef __LP64__
#define parisc_spreg_32bit(x) (((ulong_t)(x)>>30) & 0x3L)
#define parisc_spreg_64bit(x) (((ulong_t)(x)>>62) & 0x3L)

#define parisc_spreg_vas(x, vas)       (is_32ASL(vas)? \
                                parisc_spreg_32bit((ulong_t)(x)): \
                                parisc_spreg_64bit((ulong_t)(x)))
#else
/*
 * While the 64 bit macro is bogus, it's not intended to be accessed.  It's
 * only here to quiet the compiler "warning" messages.
 */
#define parisc_spreg_32bit(x) ((int)(((ulong_t)(x)>>30) & 0x3))
#define parisc_spreg_64bit(x) ((int)(((ulong_t)(x)>>30) & 0x3))
#define parisc_spreg_vas(x, vas) ((int)(((ulong_t)(x)>>30) & 0x3))
#endif /* __LP64__ */

#endif /* _HDL_VAS_INCLUDED */

