/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/int.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/int.h
 *	/usr/conf/pa/int.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


/*
 * This is the structure used by the eirr interrupt switch table to
 * vector to an interrupt handling routine based upon a specific bit
 * of eirr being set. Refer to trap.c for code dealing with this
 * structure.
 */
struct eirrswitch {
	void          (*int_action)();
	unsigned long	eiem;
	void           *int_arg;
	unsigned long   io_int;
};

/* HP_REVISIT: Redefine this macro to set the argument. */
#define eirrswitch_assign(a0, a1, a2, a3) \
	{ \
		a0[a1].int_action = a2; \
		a0[a1].eiem = a3; \
		a0[a1].int_arg = 0; \
		a0[a1].io_int = 0; \
}

#ifdef _KERNEL
extern struct eirrswitch eirr_switch[];      /* Ext. Interrupt switch table  */
#endif /* _KERNEL */
