/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/pdc/iodc_prf.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/iodc_prf.h
 *	/usr/conf/pa/iodc_prf.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef _MACHINE_IODC_PRF_INCLUDED /* allows multiple inclusion */
#define _MACHINE_IODC_PRF_INCLUDED 

#ifndef _SYS_STDSYMS_INCLUDED
#    include <sys/stdsyms.h>
#endif   /* _SYS_STDSYMS_INCLUDED  */

#ifdef _KERNEL
#    include <machine/pdc/pdc_rqsts.h>
#else
#    include <machine/pdc_rqsts.h>
#endif

#define IODC_MAX 0x8000
#define IODC_STACK_RESERVE 0x1D00
#define IODC_FRAME_SIZE 0x200
#define IODC_SPA_SHIFT_MASK 0x1F
#define IODC_BUS_MASK 0xF800
#define IODC_VSC_BUS  0x2000
#define MAX_LINE 256
#define ENTRY_FIRST_16 0
#define ENTRY_INIT     3
#define ENTRY_IO       4
#define INIT_SEARCH_FIRST 2
#define INIT_SEARCH_NEXT 2
#define INIT_MOD_AND_DEV 4
#define INIT_DEV 5
#define INIT_RETURN_MSG	9
#define INIT_DEV_WITH_STR 0x14
#define CONSOLE_READ  2
#define CONSOLE_WRITE  3
#define DELTA_TO_HPA 0x20
#define DELTA_TO_SPA 0x24
#define DELTA_TO_IODC 0x28
#define DELTA_TO_CLASS 0x2C
#define BOOT_MEM_AREA 0x3D0
#define CONSOLE_MEM_AREA 0x3A0
#define KEYBOARD_MEM_AREA 0x400
#define PATH_REMAINDER 8
#define PATH_LENGTH 32
#define BAD_IODC	0x6b	/* Bad IODC setup. */
#define CL_MASK		0xF
#define CL_RANDOM	1
#define CL_SEQU		2
#define CL_DUPLEX	7
#define CL_KEYBD	8
#define CL_DISPL	9

#define VIPER_ASP_RESET 0xf082f000
#define WIPER_ASP_RESET 0xf182f000

#ifndef LOCORE
#ifdef _KERNEL

extern void iodc_printf __((char *fmt, ...));	/* varargs */
extern void iodc_initialize_cache_parameters __((void)); 
extern void *iodc_return_console_hpa __((void));
extern void *iodc_return_console_spa __((void));
extern void iodc_set_console_hpa_and_spa __((void *hpa, void *spa));
extern int  iodc_return_spa_byte __((void *hpa));
extern void iodc_new_spa __((void *hpa, void *newspa));
extern int  iodc_allocate_iodc_buffers __((uintptr_t free_addr, 
						uintptr_t free_max));
extern void iodc_end_allocate_iodc_buffers __((physpfn_t (*page_alloc)(pgcnt_t,
			char *), void (*page_free)(physpfn_t, pgcnt_t)));
extern void iodc_console_init __((void));
extern void iodc_printf_init __((void));
extern int  iodc_printf_stat __((void));
extern int  iodc_printf_disable __((void));
extern int  iodc_printf_enable __((void));
extern void iodc_permanent_disable __((void));
extern void iodc_reinit_module __((void));
extern void iodc_cwrite __((char *string, int length));
extern void iodc_put_chassis __((int display));
extern void iodc_timer_init __((void));
extern void iodc_log_start_time __((void));
extern int  iodc_time_limit __((uint32_t seconds, uint32_t milliseconds));
extern void iodc_wait_a_sec __((void));
extern void iodc_wait_n_msec __((uint32_t nmsec));
extern void iodc_wait_n_usec __((uint32_t nusec));
extern void iodc_cputchar __((int c));
extern int  (*disk_iodc_buffer) __(());
extern caddr_t iodc_get_phys_addr __((caddr_t addr));
extern int poll_io_real_address __((ulong_t *));
extern ulong_t getCPU25 __((void));
extern unsigned char get_page0_byte __((int));
extern unsigned int  get_page0_word __((int)); 
extern void lockup __((int,int));
extern void pdc_nonblock_complete(ulong_t, pdc_pat_events_scan_rtn_block_t *);

#ifdef __LP64__
extern unsigned long inverted_space_hash_mask;
#endif

extern uint32_t *console_hpa;
extern ulong_t base_pdc_stack[];
extern ulong_t pdc_rtn_area[];
extern int pdc_does_nb_calls;
extern int pdc_does_polling_calls;
extern unsigned int __text_start;
/* the following 2 externs are included here because includeing pm/pm.h
   messes with MONITOR in iodc_prf.c */
extern int iosys_valid;
extern int initial_crash_state;
/*next extern is here because io/psm.h's includes contain debug.h which 
    defines MONITOR and causes problems in the #if below*/
extern int  console_is_foreign_module;

#endif /* _KERNEL */
#endif /* not LOCORE */

#endif /* ! _MACHINE_IODC_PRF_INCLUDED */
