/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/mp.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/mp.h
 *	/usr/conf/pa/mp.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef	_MACHINE_MP_INCLUDED
#define	_MACHINE_MP_INCLUDED

/* 
 * MAX_PROCS is the number of processors allowed. 
 */
#ifndef MAX_PROCS
#ifdef	__LP64__
#define MAX_PROCS 128	/* Range: 1 to 128 */
#else
#define MAX_PROCS 16	/* Range: 1 to 16 */
#endif	/* LP64 */
#endif /* MAX_PROCS */

#if defined(_CLEAN_BE) && !defined(LOCORE)

#include <sys/mp.h>


/*
 * For now, we have not split the PIK and PDK fields out for PA.
 * Thus the pdk_mpinfo_t follows the mpinfo_t on PA.
 * When we break out the PIK and PDK parts for PA, we will have to visit
 * 'mpinfo_t' dereferences and change the PDK field refs to use a 
 * pdk_mpinfo_t pointer.  These changes will be flagged for us by the compiler
 * when we move fields out of the PIK mpinfo_t.
 * 
 * 951114 ESCXXX
 */
#ifdef _KERNEL
typedef mpinfo_t pdk_mpinfo_t;
#endif /* _KERNEL */


extern struct mpinfo *mpproc_info, *mpproc_infoNPROCESSOR_COUNT;
extern struct processorhpa *get_my_hpa(); 

#endif /* defined(_CLEAN_BE) && !defined(LOCORE) */


#endif	/* ! _MACHINE_MP_INCLUDED */
