/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/shutdown/nvm.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/nvm.h
 *	/usr/conf/pa/nvm.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef	NVM_INCLUDED
#define	NVM_INCLUDED

/*
 *	 The various bits enable (1) or short-circuit  (0) the PDC calls
 *	 that do the real work in the NVM  functions.  In this  way, the
 *	 behavior of the kernel can be modified at run-time  through one
 *	 of the debuggers (rdb or adb).
 */
#define	GET_PANIC_OK	0x2
#define	PUT_PANIC_OK	0x1

/*
 *	 The various bits enable (1) or short-circuit  (0) the PDC calls
 *	 that do the real  work in the  chassis  display  functions.  In
 *	 this  way,  the  behavior  of the  kernel  can be  modified  at
 *	 run-time through one of the debuggers (rdb or adb).
 */
#define	PUT_CHASSIS_OK	0x1

/*
 *	Address (in NVM) of the start of the panic struct.
 */
#define	NVM_PANIC_ADDR	0x80L

/*
 *	Size (in  bytes) of the  panic  struct.  This had  better  match
 *	sizeof(struct  panic_t).  The kernel always reads and writes the
 *	minimum  of these two  values,  just in case.  The  checksum  is
 *	computed based on sizeof(prev_panic),  however.  The maintenance
 *	utility  getpanic(1m)  performs a check that these  values match
 *	and reports any difference.
 */
#define	NVM_PANIC_SIZE	128

/*
 *	A global object of this type is read from non-volatile memory
 *	(NVM) during boot.  When (and if) the system panics, this
 *	structure is updated and written back to NVM.
 */
struct panic_t {
    u_char  p_cksum;        /* 37+unsigned sum of the remaining bytes  */
    u_char  p_type;         /* panic type                              */
    u_char  p_code;         /* panic code                              */
    u_char  p_flags;        /* panic flags                             */
    short   p_pd;	    /* PD				       */
    short   p_root_cell;    /* Root cell			       */
    long    p_timeofday;    /* time of the panic (from gettimeofday)   */
    char    p_release[8];   /* initial part of uname release string    */
    char    p_version[8];   /* initial part of uname version string    */
    char    p_string[80];   /* text of the (null-term) panic string    */
#if defined(__LP64__)
    u_char  p_reserved[16]; /* reserved for future use                 */
                            /* allow for 64-bit align and size of long */
#else
    u_char  p_reserved[20]; /* reserved for future use                 */
#endif
};

/*
 *	Panic types.  The values  available  are the hex digits from 0x0
 *	thru 0xF.  It is recommended that the value 0x0 not be used.
 */
#define	PT_OS_PANIC	  0x0	/* general-purpose kernel panic */
#define	PT_OS_DUMPOK	  0x9	/* sync not done, dump went fine */
#define	PT_OS_DUMPSYNCOK  0xa	/* dump and sync went fine	*/


/*
 *	Panic codes.  The values  available  are the hex digits from 0x0
 *	thru 0xF.  These  definitions  are NOT  enclosed  in  "hp9000s800"
 *	ifdef's because the panic2() call, for which these constants are
 *	parameters, is available to systems other than "hp9000s800".
 */
#define	PC_UNKNOWN	0x0	/* no code given, or no other code applies */
#define	PC_TOC	        0x1	/* Transfer Of Control                     */
#define	PC_HPMC	        0x2	/* High Priority Machine Check             */

/*
 *	Descriptive  strings  for  panic  codes.  Used  by  the  utility
 *	getpanic(1m).
 */
#define	PC_STRINGS	{					\
			"Unknown",				\
			"Transfer Of Control",			\
			"High-Priority Machine Check",		\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved",				\
			"reserved"				\
			}


/*
 *	Panic flags.  This is a one byte field of one bit flags.
 */
#define	PF_NONE		0x0	/* all flags off */

/*
 *	The processor slot number is in bits 14-17 of the processor HPA.
 */
#define	CPU_SLOT	(((processor_hpa) >> 14) & 0xF)

/*
 *	Addess (within NVM) of the dump header location structure.
 */
#define NVM_DUMPLOCATION_ADDR	0x100L

/*
 *	Size (in bytes) of the dump header structure.  This had better
 * 	match sizeof(struct dumplocation_t).  The kernel always reads
 *	and writes the minimum of these two values, just in case.
 */
#define NVM_DUMPLOCATION_SIZE	24

#endif	/* NVM_INCLUDED */
