/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/pcb.h		$Revision: $
 * 
 *  Purpose:
 *	HP Precision Architecture process control block
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/pcb.h
 *	/usr/conf/pa/pcb.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef _MACHINE_PCB_INCLUDED /* allows multiple inclusion */
#define _MACHINE_PCB_INCLUDED

#ifndef _SYS_STDSYMS_INCLUDED
#    include <sys/stdsyms.h>
#endif   /* _SYS_STDSYMS_INCLUDED  */

typedef struct pcb {
	unsigned long	pcb_r1; 
	unsigned long	pcb_r2; 
	unsigned long	pcb_r3; 
	unsigned long	pcb_r4; 
	unsigned long	pcb_r5; 
	unsigned long	pcb_r6; 
	unsigned long	pcb_r7; 
	unsigned long	pcb_r8; 
	unsigned long	pcb_r9; 
	unsigned long	pcb_r10; 
	unsigned long	pcb_r11; 
	unsigned long	pcb_r12; 
	unsigned long	pcb_r13; 
	unsigned long	pcb_r14; 
	unsigned long	pcb_r15; 
	unsigned long	pcb_r16; 
	unsigned long	pcb_r17; 
	unsigned long	pcb_r18; 
	unsigned long	pcb_r19; 
	unsigned long	pcb_r20; 
	unsigned long	pcb_r21; 
	unsigned long	pcb_r22; 
	unsigned long	pcb_r23;
	unsigned long	pcb_r24; 
	unsigned long	pcb_r25; 
	unsigned long	pcb_r26; 
	unsigned long	pcb_r27;
	unsigned long	pcb_r28; 
	unsigned long	pcb_r29; 
	unsigned long	pcb_r30; 
	unsigned long	pcb_r31;

	unsigned long	pcb_sr0;
	unsigned long	pcb_sr1;
	unsigned long	pcb_sr2;
	unsigned long	pcb_sr3;
	unsigned long	pcb_sr4;
	unsigned long	pcb_sr5;
	unsigned long	pcb_sr6;
	unsigned long	pcb_sr7;

	unsigned long	pcb_cr0;
	unsigned long	pcb_cr8;
	unsigned long	pcb_cr9;
	unsigned long	pcb_cr10;
	unsigned long	pcb_cr11;
	unsigned long	pcb_cr12;
	unsigned long	pcb_cr13;
	unsigned long	pcb_cr14;
	unsigned long	pcb_cr15;
	unsigned long	pcb_cr16;
	unsigned long	pcb_cr17;
	unsigned long	pcb_cr18;
	unsigned long	pcb_cr19;
	unsigned long	pcb_cr20;
	unsigned long	pcb_cr21;
	unsigned long	pcb_cr22;
	unsigned long	pcb_cr23;
	unsigned long	pcb_cr24;
	unsigned long	pcb_cr25;
	unsigned long	pcb_cr26;
	unsigned long	pcb_cr27;
	unsigned long	pcb_cr28;
	unsigned long	pcb_cr29;
	unsigned long	pcb_cr30;
	unsigned long	pcb_cr31;

	unsigned long	pcb_pc; 	/* program counter */
	unsigned long	pcb_psw; 	/* program status word */
	unsigned long	pcb_ipsw;
	unsigned long	pcb_pcsqe;	/* pcsq end */
	unsigned long	pcb_pcoqe;	/* pcoq end */
	unsigned long	pcb_ksp;	/* kernel stack pointer */
				/* should be zero (if the kernel stack */
				/* is in used and sp should point to the */
				/* top of the kernel stack) or the top */
				/* of the kernel stack */

	double	pcb_fr0;
	double	pcb_fr1;
	double	pcb_fr2;
	double	pcb_fr3;
	double	pcb_fr4;
	double	pcb_fr5;
	double	pcb_fr6;
	double	pcb_fr7;
	double	pcb_fr8;
	double	pcb_fr9;
	double	pcb_fr10;
	double	pcb_fr11;
	double	pcb_fr12;
	double	pcb_fr13;
	double	pcb_fr14;
	double	pcb_fr15;
	double	pcb_fr16;
	double	pcb_fr17;
	double	pcb_fr18;
	double	pcb_fr19;
	double	pcb_fr20;
	double	pcb_fr21;
	double	pcb_fr22;
	double	pcb_fr23;
	double	pcb_fr24;
	double	pcb_fr25;
	double	pcb_fr26;
	double	pcb_fr27;
	double	pcb_fr28;
	double	pcb_fr29;
	double	pcb_fr30;
	double	pcb_fr31;

	/*
	 * Software pcb (extension)
	 */
	int	*pcb_sswap;
	struct vfd *pcb_p0br;	/* base and length register for segments */
	int	pcb_p0lr;
	struct vfd *pcb_p1br;
	int	pcb_p1lr;
	struct vfd *pcb_p2br;	/* these follow VAX convention for	*/
	int	pcb_p2lr;	/* p1br and p1lr		 	*/
	int	pcb_sigc[3];
	int     pcb_escapecode;
	struct  C__trystuff *pcb_trychain;
} pcb_t;
#define _PCB_T

/*
 * Useful aliases
 */

/*
 * Args 4 through 7 are defined only for 64-bit runtime architecture and
 * only when the PSW-W bit is 1.  These registers are the same as those
 * used for temporary registers T1-T4; these temporary registers should
 * not be used in wide mode for procedures which have more than four 
 * arguments.
 */

#ifdef __LP64__
#define	pcb_arg7	pcb_r19
#define	pcb_arg6	pcb_r20
#define	pcb_arg5	pcb_r21
#define	pcb_arg4	pcb_r22
#define pcb_gp          pcb_r27
#endif /* __LP64__*/

#define	pcb_arg3	pcb_r23
#define	pcb_arg2	pcb_r24
#define	pcb_arg1	pcb_r25
#define	pcb_arg0	pcb_r26
#define	pcb_dp		pcb_r27
#define	pcb_fp		pcb_r28
#define	pcb_ap		pcb_r29
#define	pcb_sp		pcb_r30
#define pcb_usp		pcb_r30

/*
 * thread_pcb_init() needs a place to stuff a couple values to be
 * read by kthread_daemon_startup().  These are handy.
 */
#define pcb_kthread_daemon_startup_func	pcb_arg0
#define pcb_kthread_daemon_startup_arg	pcb_arg1

#define LPRIV_XFR_ON	0x00400000	/* Turn on the lower-privilege */
					/* transfer trap.  So, when it */
					/* returns to the user, it will */
					/* cause a trap. */

/*
 * This macro will set the L bit in the global psw.
 */
#define async_trap_on() (rfi(rsm(0) | PSW_L, 0))

/*
 * This macro will clear the L bit in the global psw.
 */
#define async_trap_off() (rfi(rsm(0), PSW_L))

/*
 * The old macros aston() and astoff() are no longer used or supported.
 * This is an MP kernel now.  You should use the mpsched_set() and
 * mpsched_clear() functions now.
 */

#endif /* ! _MACHINE_PCB_INCLUDED */
