/*
 * BEGIN_DESC
 * 
 *  File: 
 * @(#) pde.h $Date: 2002/12/06 11:51:23 $Revision: r11.11/2 PATCH_11.11 (PHKL_28393) 
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/pde.h
 *	/usr/conf/pa/pde.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef	_MACHINE_PDE_INCLUDED
#define	_MACHINE_PDE_INCLUDED

#include <machine/param.h>	/* kernel src: <machine/sys/param.h> */
#include <sys/vmmac.h>

#define MP_SPARSE_PDIR

#ifndef LOCORE

#define PDE_VPAGE PGNDXWDTH
#define PDE_VOFF PGSHIFT

#define PDE_PPAGE PGNDXWDTH

extern int mainentered;
extern int cpu_arch_is_2_0; 
extern struct hpde2_0 **pgtopde_table2_0; 

/* Convert virtual page to the fifteen-bit format used within the pde */
#define VPAGE_TO_PDE_VPAGE(vpage) ((u_long)(((u_long)vpage >> 5) & 0x7FFF))

/* Notes on pde structure:
 * Separating spaces indicate boundaries between words within the
 * structure.  There is a field in the comment at the end of each field
 * that indicates that is flagged 'T', 'H', both, or neither.  An 'H' indicates
 * that the field affects the hardware and it's placement is critical.
 * A 'T' indicates that certain implementations require placement of the field
 * in the indicated position.  Those marked neither 'T' nor 'H' are simply
 * software conventions.
 */

/* SCF - "Stingy cache flush." */

typedef	unsigned long pagef_t;

/* page info structure */
typedef struct pfn_to_virt_entry {
	space_t space;
	union {
		unsigned long offset_page;
		struct alias *alias;
	} alias_or_offset;	
} pfn_to_virt_entry_t;

struct pfn_to_virt_ptr {
	pfn_to_virt_entry_t	*pp_tbl;
	int			pp_offset;
};

#define PFN_TO_VIRT(PFN)	(&pfn_to_virt_ptr[PFN_BASE(PFN)].pp_tbl[PFN_OFFSET(PFN)])

/* address aliasing structure */
typedef struct alias {
	struct alias *aa_next; /* prev aliased space,offset */
	space_t	space;
	unsigned int aa_savear          :7;
	prot_t  aa_saveprot             :25;
	unsigned long offset_page;
} alias_t;


/* If there is no translation for the page, return 1; otherwise
 * (i.e., if there *is* a translation) return 0.
 *
 * Rather than a PFN, the caller must supply a pfn_to_virt_entry_t
 * pointer, i.e., the result of PFN_TO_VIRT(PFN), as the argument.  This
 * allows us to avoid doing the PFN_TO_VIRT lookup twice.
 *
 * For best performance, the caller should call PFN_TO_VIRT(PFN)
 * and cache the result:
 *
 *	pfn_to_virt_entry_t *ptov = PFN_TO_VIRT(PFN);
 *	if (NO_TRANS(ptov)) { ...
 *
 * "NO_TRANS(PFN_TO_VIRT(PFN))" still does the lookup twice
 * due to the macro expansion.
 */
#define NO_TRANS(PTOV)	\
	(((PTOV->space == INVALID_SPACE_ENTRY) && \
	(PTOV->alias_or_offset.offset_page == INVALID_OFFSET_PAGE_ENTRY)) \
	? 1 : 0)

/* If the page is aliased, return 1; otherwise return 0.
 *
 * Again, the caller must supply a pfn_to_virt_entry_t pointer,
 * for the same reason as in NO_TRANS() above.
 */
#define ALIASPAGE(PTOV)	\
	(((mainentered) && \
	(PTOV->space == INVALID_SPACE_ENTRY) && \
	(PTOV->alias_or_offset.offset_page != INVALID_OFFSET_PAGE_ENTRY)) \
	? 1 : 0)

/* HDL_ALIASPAGE() checks whether 'pfn' is an aliased page. */
#define HDL_ALIASPAGE(pfn)      ALIASPAGE(PFN_TO_VIRT(pfn))

typedef struct hpde {
 
  /* Word 0 */
    volatile
	unsigned int	pde_valid	:1;	/* Valid bit                T */
	unsigned int	pde_vpage	:15;	/* V. page - high 15 bits   T */
	unsigned int	pde_space	:16;	/* Virtual space number     T */

  /* Word 1 */
    volatile
	unsigned int	pde_ref		:1;	/* Reference bit            T */
    volatile
	unsigned int	pde_accessed	:1;	/* SCF flag-may be in cache   */
	unsigned int	pde_rtrap	:1;	/* Data ref trap enable bit  H*/
    volatile
	unsigned int	pde_dirty	:1;	/* Dirty bit                 H*/
	unsigned int	pde_dbrk	:1;	/* Data break                H*/
	unsigned int	pde_ar		:7;	/* Access rights             H*/
	unsigned int    pde_uncache	:1;	/* Uncache bit               H*/
    volatile
	unsigned int	pde_protid	:18;	/* Protection ID             H*/
    volatile
	unsigned int	pde_executed	:1;	/* SCF flag - in I-cache      */

  /* Word 2 */
    volatile
	unsigned int	pde_uip		:1;	/* Update in progress.        */
	unsigned int			:31-5-PDE_PPAGE;
	unsigned int	pde_phys	:PDE_PPAGE; /* Physical page        TH*/
	unsigned int 			:1;
    volatile
	unsigned int	pde_modified	:1;	/* VM high-lvl page-mod bit   */
	unsigned int	pde_ref_trickle	:1;     /* Trickle-up bit for ref's.  */
	unsigned int	pde_block_mapped:1;	/* Block mapping flag         */
	unsigned int	pde_alias	:1;	/* Virtual alias field        */

  /* Word 3 */
	struct hpde    *pde_next;		/* Next entry               T */

} hpde_t;

typedef struct hpde * 	hpde_handle_t;	/* just a handle, not to be deref'd */

	/* Word oriented hpde structure, for fast moves */
typedef struct whpde {
    volatile
	unsigned int	wpde_vaddr;   /* Virtual space, page, and valid bit */
    volatile
	unsigned int	wpde_acword;	
    volatile
	unsigned int	wpde_phys;	
	unsigned int	wpde_next;	
} whpde_t;


/*
 * PDE_LOG2 - log2(size of a pdir entry).  Used by handlers
 * to index into pdir array. Sparse pdir doesn't index into hash table in
 * handlers. Include it since people may expect it to be here.
 */
#define PDE_LOG2	5	/* LOG2(sizeof(struct pde)) */

#define PROTID_SHIFT		 1
#ifdef _KERNEL
/*
 * N.B. There are no PDIR entries below base_pdir or above max_pdir, but
 * it is *not* the case that everything between base_pdir and max_pdir
 * is necessarily a PDIR entry.  There might even be holes in memory
 * between them.
 */
extern struct hpde *base_pdir;	/* Pointer to lowest valid pde address. */
extern struct hpde *max_pdir;	/* Pointer to highest valid pde address+1. */
extern struct hpde *pdir;	/* Pointer to non-hashed pde entries. */
extern struct hpde *htbl;	/* Pointer to hash table */
extern struct pfn_to_virt_ptr *pfn_to_virt_ptr;
extern struct hpde *htbl_end;	/* Pointer to end of hash table */
extern hpde_handle_t vtopde();
extern unsigned int scaled_npdir;
extern unsigned int npdir;	/* Number of (positive) pdir entries */
extern unsigned int nhtbl;	/* Number of htlb entries */
extern struct lock *alias_lock;     /* address aliasing hash lock */


/*
 * These constants are used when enabling the HW walker for a PCX-T
 * system. They tell the enabling function if we are under powerfail
 * recovery.
 *
 * In the future, all of these processor dependent constants should
 * probably have their own header file.
 */
#define HWTLB_PFAIL_ENABLE	1
#define HWTLB_NORMAL_ENABLE	0

#endif /* _KERNEL */

#define PDE_INVALID 0x0000FFFF

#define	NUMPDIR			(NBPG/sizeof(struct hpde))
#define	NUMALIAS		(NBPG/sizeof(struct alias))
#define HPDIRFREE	0xffffffff

#define ACCESS_SHIFT (20)

#ifdef __LP64__
/*
 * The following diagram helps determining the user virtual address from the
 * physical IO address. If the IO address is already, fully extended,
 * it is mapped into the top of 4GB. (These addresses should be 
 * 32 bit mappable PDC or 32 bit mappable IO addr). If the IO addr
 * is 40 bit, then we map it into just above 4GB. If it is 32 bit
 * IO address, we map it into top 256MB of 4GB as in the first quad.
 *
 * 40Bit IO Phys
 *    Layout
 *
 * -------------- <-- (A) Start of 40 bit PDC 
 * 0xF0'0000 0000
 *
 *
 * 0xF0'EFFF FFFF
 * -------------- <-- (B) 
 * 0xF0'F000 0000
 *
 *       I	  <-- 40 bit PDC mapped to top 256MB of 4GB virt space
 *  
 * 0xF0'F0FF FFFF
 * -------------- <-- (C) 
 * 0xF0'F100 0000
 *
 *
 * 0xF0'FFFF FFFF
 * -------------- <-- (D) Start of 40 bit IO  
 * 0xF1'0000 0000 
 *
 *
 *
 * 0xFF'F0FF FFFF
 * -------------- <-- (E) 
 * 0xFF'F100 0000
 *
 *	 II	  <-- 40 bit IO mapped to top 256MB of 4GB virt space
 *
 * 0xFF'FFFF FFFF
 * -------------- <-- (F) 
 *
 */

/* 
 * IO Physical space is 1/16th of a 1TB (in 40 bit phys address space).
 * Of this, only 256MB is mappable into top 256MB of 32 bit (4GB) user virt
 * space. The rest (accessible only for 64 bit users, we need a place to
 * map. We map it into about 4GB in 64 bit first quad and this macro
 * sizes the needed virt space.
 */
#define USER64_40BIT_IOPAGES  ((0x10000000000L / 16) / NBPG)

/* Determine if the address is 64 bit extended (from 32 or 40 bit addr) */
#define IS_EXTENDED_IOADDR(addr) 					\
	(((uintptr_t) (addr) >= (uintptr_t) 0xFFFFFFF000000000 && 	\
  	  (uintptr_t) (addr) <= (uintptr_t) 0xFFFFFFFFFFFFFFFF))

/* 
 * Determine if the 64 bit extended address can be mapped within 4GB.
 * 64 bit extended 32 bit PDC, or 32 bit IO addr are such candidates.
 * Their 40 bit counterparts as well, will be so, i.e, currently
 * address extention to 32 bit or 40 bit phys IO addr is supported.
 */
#define IS_4GB_MAPPABLE_IOADDR64(addr)					\
	(((uintptr_t) (addr) >= (uintptr_t) 0xFFFFFFF0F0000000  &&	\
	  (uintptr_t) (addr) <= (uintptr_t) 0xFFFFFFF0F0FFFFFF) ||	\
	 ((uintptr_t) (addr) >= (uintptr_t) 0xFFFFFFFFF1000000  &&	\
	  (uintptr_t) (addr) <= (uintptr_t) 0xFFFFFFFFFFFFFFFF))

/* Determine if the IO phys addr is 32 bit or 40 bit */
#define IS_32BIT_IOADDR(addr) 						\
	(((uintptr_t) (addr) & (uintptr_t) 0xFFF0000000) == 		\
			       (uintptr_t) 0xF0000000)
#define IS_40BIT_IOADDR(addr) 						\
	(((uintptr_t) (addr) & (uintptr_t) 0xF000000000) ==       	\
			       (uintptr_t) 0xF000000000)

/*
 * Determine user virt addr from 40 bit addr 
 * If addr is in 40 bit PDC or IO that is mappable with in 4GB
 *	map within 4GB
 * else
 *	map it beyond 4GB
 */
#define IOADDR40_TO_UADDR(addr) 					\
	((((uintptr_t) (addr) >= (uintptr_t) 0xF0F0000000  && 		\
	   (uintptr_t) (addr) <= (uintptr_t) 0xF0F0FFFFFF) ||		\
	  ((uintptr_t) (addr) >= (uintptr_t) 0xFFF1000000  && 		\
	   (uintptr_t) (addr) <= (uintptr_t) 0xFFFFFFFFFF)) ?		\
	 (((uintptr_t) (addr) &  (uintptr_t)   0xFFFFFFFF)) :		\
	 (((uintptr_t) (addr) &  (uintptr_t)  0xFFFFFFFFF) + 		\
				 (uintptr_t)  0x100000000))

/* Convert 32 bit IO Addr to 64 bit */
/* 
 * Determine user virt addr from IO phys addr. 
 * If the address is 64 bit extended and
 *	if it is mappable within 4GB, map it there
 *	else map it to beyond 4GB
 * else if it is 40 bit address
 *		map it with IOADDR40_TO_UADDR()
 *	else
 *		map it within 4GB as it is.
 */
#define IOADDR_TO_UADDR(addr)						\
	(IS_EXTENDED_IOADDR(addr) ?					\
	 (IS_4GB_MAPPABLE_IOADDR64(addr) ?				\
	  (((uintptr_t) (addr) & (uintptr_t)  0xFFFFFFFF)) :		\
	  (((uintptr_t) (addr) & (uintptr_t) 0xFFFFFFFFF) + 		\
				 (uintptr_t) 0x100000000)) :		\
	 (IS_40BIT_IOADDR(addr) ?					\
	  IOADDR40_TO_UADDR(addr) :					\
	  (uintptr_t) (addr)))

#define CONVERT_IOADDR_32TO64(addr)   					\
	((((uintptr_t) (addr) & (uintptr_t)         0xFF000000) == 	\
				(uintptr_t)         0xF0000000) ? 	\
	 ((uintptr_t) (addr) |  (uintptr_t) 0xFFFFFFF000000000) : 	\
	 ((uintptr_t) (addr) |  (uintptr_t) 0xFFFFFFFF00000000))

/* Convert 40 bit IO Addr to 64 bit */
#define CONVERT_IOADDR_40TO64(addr) 				 	\
	 ((uintptr_t) (addr) | (uintptr_t) 0xFFFFFF0000000000)

/* Convert an IO Addr to 64 bit */
#define EXTEND_ADDR(addr) 						\
	(IS_40BIT_IOADDR(addr) ? CONVERT_IOADDR_40TO64(addr) :		\
				 CONVERT_IOADDR_32TO64(addr))

/* Convert 64 bit IO Addr to 32 bit */

/* Macro modified to function call wrapper for JAGad34969 patch.
 * 11/29/2000 - Don Morris
 *
 * #define CONVERT_IOADDR_64TO32(addr)   ((uintptr_t) addr & 		\
 *				       (uintptr_t) 0x00000000FFFFFFFF)
 *
 */

typedef struct io32_remap_entry{
	struct io32_remap_entry *re_next;
	uintptr_t re_physaddr;
	uint64_t re_size;
	uintptr_t re_virtaddr;
} io32_remap_entry_t;

extern uintptr_t convert_ioaddr_64to32 __((uintptr_t));

#define CONVERT_IOADDR_64TO32(addr) 					\
	(caddr_t)(convert_ioaddr_64to32((uintptr_t)addr))

#define IS_40BIT_IOPFN(addr) 						\
		(((uintptr_t) (addr) & (uintptr_t) 0xF000000) == 	\
				       (uintptr_t) 0xF000000)
/* Convert 32 bit IO pfn to 64 bit */
#define CONVERT_IOPFN_32TO64(pfn) 					\
	((((pagef_t) (pfn) & (pagef_t) 0xFF000) == (pagef_t) 0xF0000) ?	\
	 ((uintptr_t) (pfn) | (uintptr_t) 0x000FFFFFFF000000) :		\
	 ((uintptr_t) (pfn) | (uintptr_t) 0x000FFFFFFFF00000))

/* Convert 40 bit IO pfn to 64 bit */
#define CONVERT_IOPFN_40TO64(pfn) 					\
	 ((uintptr_t) (pfn) | (uintptr_t) 0x000FFFFFF0000000)

/* Convert a IO pfn to 64 bit */
#define EXTEND_IOPFN(pfn) 						\
	(IS_40BIT_IOPFN(pfn) ? CONVERT_IOPFN_40TO64(pfn) :		\
			       CONVERT_IOPFN_32TO64(pfn))
#else
#define EXTEND_ADDR(addr) (addr)
#define EXTEND_IOPFN(pfn) (pfn)
#define CONVERT_IOADDR_32TO64(addr)   (addr)
#define CONVERT_IOADDR_64TO32(addr)   (addr)
#endif

/* For pfn_to_virt_table */
#define INVALID_SPACE_ENTRY 0xFFFFFFFFUL
#define INVALID_OFFSET_PAGE_ENTRY 0

/* For pdes */
#define INVALID_SPACE 0xFFFF
#define INVALID_OFFSET 0x0
#define ALIAS_RESERVED 0x1
#define ALIAS_RELEASE 0x2
#define EMPTY_ENTRY 0x0000FFFF
#define INVALID_PROT_WORD 0x0;


/* DEFAULT_SPACE_IDs must be a power of 2. */
/* XXX_THREAD_XXX: Increase spaceid's to 0-65535. */
#define DEFAULT_SPACE_IDs	32768	/* Default space IDs 0-32767 */
					/* Real maximum is 262144 */

/* MAX_PROTID_IDs must be a power of 2. */
#define MAX_PROTID_IDs	32768	/* Valid protection IDs 0-32767 */

#define INVALID_SPACE1 (0xFFFF)
#define INVALID_SPACE2 (0xFFFFFFFF)
#define INVALID_SPACE_ID        (space_t) -1
#define INVALID_PROT_ID         (prot_t)  -1

/* 
 * When 1/2 a hash bucket is empty it should contain a ref bit of 0 and a 
 * physical page of 0
 */
#define HPHYSINV	0x0
#define HREFINV		0x0
#define HOSINV		0x0

/*
 * The following hash function produces a 32 bit index, (hopefully)
 * more than we will ever need.
 */
#define pdirhash1_1(sid, sof) ((u_long) (space_t)(sid << 5 ) ^ \
				((u_long) (sof) >> (PGSHIFT)))
/*
 * For pdirhash2_0, the "unsigned" casts are very important---they preclude
 * sign extension on the right shift.
 */

#define pdirhash2_0(sid, sof) ((((u_long) (sid)) >> GVA_OFFSET_BITS) ^   \
				(((u_long) (sof)) >> PGSHIFT))

#endif /* LOCORE */

#ifdef __LP64__
/* 
 * Define the maximum number of entries in the PDIR hash table for
 * 64 bit systems.  We are currently limiting it to 25 bits to constrain
 * the size of the hash to 1Gbyte (2^25 * 32).
 */
#define HASH_PDIR_BITS	25
#else
/*
 * Define maximum number of entries in the PDIR hash table.
 * This is limited by the maximum index width returned by pdirhash1_1().
 * The PA TLB hardware walkers limit the hash to a 20 bit maximum index.
 */
#define HASH_PDIR_BITS	20
#endif

#define HASH_PDIR_MAX   (1<<(HASH_PDIR_BITS))

/* 
 * NPDIR_LOCKS must be a power of two. This is asserted in realmain()
 */
#define NPDIR_LOCKS 1024
/* PD_LOCK_MASK == (NPDIR_LOCKS - 1) */
#define PD_LOCK_MASK 1023

/*
 * Low Level Lock mask for PA2.0 targets. The lock mask must match the
 * lock low level lock array, pd_ll_locks,  defined in asm_tlb2_0.s.
 */
#define LL_PD_LOCK_MASK  127

/* Constants related to field positions within the PDE structure, and used
 * by the low-level code for greater readability.
 */
#define	PDE_VADDR	0
#define	PDE_PROT	4
#define	PDE_PPN 	8
#define	PDE_NEXT	12
#define	PDE_UIP_BYTE	8
#define	PDE_UIP_BIT	24
#define	PDE_UIP_WBIT	0
#define PDE_OS			28
#define UBIT_SHIFT	19
#define PDE_BLOCKED_MAPPED 30
#define PDE_REF_TRICKLE_POS 29

#define PA83_ODD_PAGE	20

/* HSPOS (Hash Shift POSition) is the low-order bit position of the space-ID
 * in the selected hash algorithm.
 */
#define	HSPOS   	26

/* HSWDTH (Hash Shift WiDTH) is the number of bits retained from the space-ID
 * in the selected hash algorithm.
 */
#define	HSWDTH 		16

#define PDE_MATCH       0x1     /* flag to check if pfn and va match */
#define PDE_TRANS       0x2     /* flag to check if pfn translated   */
#define PDE_ALL         0x4     /* flag to check all pdes mapped     */
#define PDE_SAVE        0x8     /* flag to save current pde values   */
#define PDE_RESET       0x10    /* flag to reset to saved pde values */
#define PDE_LOCKOK      0x20    /* flag indicates no check on locks needed */
#define PDE_ALIAS       0x40    /* flag indicates pde from alias pde pool */
#ifdef __LP64__
#define PDE_EXECUTE	0x80	/* flag indicates execute preferred for RWX */
#endif

#define NONALIAS	0x0	/* non-alias type */
#define ALIAS		0x1	/* type of alias  */
#define ALIAS_REMAP	0x2	/* type of alias remapping */
/*
 * Access rights are now given out on a region basis, thus all the pages
 * in a region have the same access.
 */
#define	PDE_AR_KR	0x00
#define	PDE_AR_KRW	0x10
#define	PDE_AR_KRX	0x20
#define	PDE_AR_KRWX	0x30

#define	PDE_AR_UR	0x0f
#define	PDE_AR_URW	0x1f
#define	PDE_AR_URX	0x2f
#define	PDE_AR_URWX	0x3f
#define PDE_AR_UX	0x7f

#define	PDE_AR_URKW	0x1c
#define	PDE_AR_URWKW	0x1f
#define	PDE_AR_URXKW	0x3c
#define	PDE_AR_URWXKW	0x3f
#define PDE_AR_INVALID	0xff

#define PDE_HASEXECUTE	0x20
#define PDE_HASWRITE	0x10
#define PDE_AR_GX	0x4c

#define PDE_REF_POS        0
#define PDE_ACCESSED_POS   1
#define PDE_RTRAP_POS      2
#define PDE_DIRTY_POS      3
#define PDE_DBRK_POS       4
#define PDE_UNCACHE_POS   12
#define PDE_EXECUTED_POS  31


#define PDE_MODIFIED_POS  28

#define PDE_REF_BIT       0x80000000
#define PDE_ACCESSED_BIT  0x40000000
#define PDE_RTRAP_BIT     0x20000000
#define PDE_DIRTY_BIT     0x10000000
#define PDE_DBRK_BIT      0x08000000
#define PDE_UNCACHE_BIT   0x00080000
#define PDE_EXECUTED_BIT  0x00000001
#define PDE_MODIFIED_BIT  0x00000008

/* Also keep old ones for now  XXX */

#define PDE_AR_URKW	0x1c
#define PDE_AR_KXR	0x20
#define PDE_AR_KXRW	0x30
#define PDE_AR_KXUX	0x2c
#define PDE_AR_KX	0x20
#define	PDE_AR_UXRW	0x3f
#define	PDE_AR_UXR	0x2f
#define PDE_AR_CWX	PDE_AR_UXR
#define PDE_AR_CW	PDE_AR_UR
#define PDE_AR_URXKW	0x3c

/*
 * Since the address space layout differs between 64-bit and 32-bit
 * processes, spreg() is modal for a wide kernel.
 */
#ifdef __LP64__
#define spreg(x)        (is_32bit(u.u_procp)? \
				(((uintptr_t)x>>30) & 0x3): \
				(((uintptr_t)x>>62) & 0x3))
#else
#define spreg(x)        ((int)(((uintptr_t)x>>30) & 0x3))
#endif /* __LP64__ */

#define NIOPDE	2*256	/* number of pde's for I/O area of PDIR */
#define SIOPDE	2*1	/* negative start of valid pde's for I/O area of PDIR */

/* Access rights equates as defined by Azure kernel */
#define PDE_AR_GATE	PDE_AR_GX
#define PDE_AR_URXKR	PDE_AR_UXR
#define PDE_AR_NOACC	0x73
#define PDE_AR_TRANSIT	0x72  /* No Access, page being pushed out. */


#define PIDMASK		0xfffe
#define PROTID_MASK	0xffff
#define PROTID_RESTRICT	0x80000000
#define PROTID_REST_POS	0
#define PROTID_SUSPEND	0x40000000
#define PROTID_SLEEPERS	0x20000000
#define PROTID_DELETED	0x10000000
#define ACWMASK 	0x07F0FFFE

#define PDE_SHADOW_OFF 1
#define PDE_SHADOW_BIT 0x20000
#define PDE_SHADOW_BOFFSET NBPG
#define PDE_ODD_BIT NBPG


/*
 * The following are defination for the PA2.0 vm_pdir format.
 */

#define TWO_GIGS_OF_MEM 0x80000000
#define HPHYSINV_U 0x0
#define HPHYSINV_L 0x0
#define PDE2_0_INVALID_OFF 0x80000000
#define PDE2_0_INVALID_SPACE 0xFFFFFFFF
#define ENTRY_IN_USE 1
#define FREE_ENTRY 0
#define PDE2_0_INV_ACWORD_U 0x0
#define PDE2_0_INV_ACWORD_L 0x0
#define PHYS_PAGE_32_MASK 0xFFFFF
#define AR_O_P_RT_M_MASK 0x07F62100
#define PDE2_0_INVALID 1
#define PDE2_0_VALID 0
#define PDE2_0_REF_TRICKLE_MASK 0x00002000
#define PDE_REF_TRICKLE_MASK 0x00000004

/*
 * IOR_VPN_BITS          - number of virtual page number bits in IOR 
 * ISR_VPN_BITS          - number of virtual page number bits in ISR
 *			   N.B. This must match GVA_OFFSET_BITS
 * PDE_VPAGE_BITS        - number of bits contained within the the pde_vpage 
 *			   field
 *			   Note: PDE_VPAGE_BITS never needs to extend past
 *				 20 bits due to the fact that remaining bits
 *				 of the virtual page number are the
 *				 ISR_VPN_BITS contained within pde_space
 *
 * ISR_SPACE_BITS	 - number of significant space bits.  N.B.  The TLB
 *			   code assumes the upper 32 bits of a 64 bit space
 *			   register are always zero.
 */
#define IOR_VPN_BITS		20
#define ISR_VPN_BITS		10
#define ISR_TO_IOR_VPN_BITNO	31-IOR_VPN_BITS
#define PDE_VPAGE_BITS		20
#define ISR_SPACE_BITS		32-ISR_VPN_BITS

#ifndef LOCORE


/* Local names for int32 types */
typedef int32_t int32 ;
typedef uint32_t u_int32 ;


typedef struct hpde2_0 {
 
  /* Double Word 0 */
    volatile
	u_int32		pde_invalid	:1;	/* invalid bit              T */
	u_int32				:31-PDE_VPAGE_BITS;/* Must be zero's...        T */
	u_int32		pde_vpage	:PDE_VPAGE_BITS;/* V. page - high 20 bits   T */
	u_int32		pde_space	:32;	/* Virtual space number     T */

  /* Double Word 1 */
	u_int32				:2; 	/* Reserved		      */
	u_int32		pde_rtrap	:1;	/* Data ref trap enable bit H */
    volatile
	u_int32		pde_dirty	:1;	/* Dirty bit                H */
	u_int32		pde_dbrk	:1;	/* Data break               H */
	u_int32		pde_ar		:7;	/* Access rights            H */
	u_int32  	pde_uncache	:1;	/* Uncache bit              H */
	u_int32  	pde_order	:1;	/* Strong Ordering bit      H */
	u_int32  	pde_br_predict	:1;	/* Branch Predicton bit     H */
	u_int32				:3; 	/* Reserved		      */
	u_int32		pde_ref_trickle :1;	/* Trickle up bit for Ref     */
	u_int32		pde_block_mapped :1;	/* Block mapping flag         */
    volatile
	u_int32		pde_executed	:1;	/* SCF flag - in I-cache      */
    volatile
	u_int32		pde_ref         :1;	/* Reference bit            T */
    volatile
	u_int32		pde_accessed	:1;	/* SCF flag-may be in cache   */
    volatile
	u_int32		pde_modified	:1;	/* VM high-lvl page-mod bit   */

	u_int32				:7;   	/* Make sure uip has a byte   */
						/*  all to itself...          */
    volatile
	u_int32		pde_uip		:1;	/* Update in progress.        */

    volatile  /* ? */
	u_int32		pde_protid	:31;	/* Protection ID            H */
	u_int32		pde_os		:1;     /* Entry in Use Flag          */

  /* Double Word 2 */
        u_int32		pde_alias	:1;	/* Alias Page                 */
#ifdef __LP64__
	u_int32		pde_wx_demote	:1;	/* user space fic	      */
#else
	u_int32				:1;	/* Software Reserved          */
#endif
	u_int32				:5;	/* Reserved 		      */
	u_int32		pde_phys_u	:25;	/* Unused part of physical    */
					      	/*  page field	              */
	u_int32		pde_phys	:27;  	/* Physical page            TH*/
	u_int32		var_page	:5;	/* Variable page size field   */

  /* Double Word 3 */
#ifdef __LP64__

#define PDENEXT_CAST(x)	((struct hpde2_0 *) x)
	struct hpde2_0	*pde_next;		/* Next entry		      */

#else /* __LP64__ */

	u_int32 	unused_upper; 		/* Unused upper half 	      */
#define PDENEXT_CAST(x)	((u_int32) x)
	u_int32 	pde_next;		/* Next entry               T */

#endif /* __LP64__ */
 
} hpde2_0_t;



	/* Word oriented hpde structure, for fast moves */
typedef struct whpde2_0 {
    volatile
	u_int32 	wpde_vaddr_u;  
    volatile
	u_int32		wpde_vaddr_l;  
    volatile
	u_int32		wpde_acword_u;	
    volatile
	u_int32		wpde_acword_l;	
#ifdef __LP64__

#define SET_INVALID_PHYS(x)	(x)->wpde_phys = HPHYSINV
#define ASSIGN_WPDE_PHYS(a,b)	(a)->wpde_phys = (uint64_t)(b)
    volatile
	uint64_t	wpde_phys;
	uint64_t	wpde_next;

#else /* __LP64 */

#define SET_INVALID_PHYS(x)				\
	(x)->wpde_phys_u = HPHYSINV_U;			\
	(x)->wpde_phys_l = HPHYSINV_L;
#define ASSIGN_WPDE_PHYS(a,b)				\
	(a)->wpde_phys_l = (uint32_t)(b)
    volatile
	u_int32		wpde_phys_u;	
    volatile
	u_int32		wpde_phys_l;	
	u_int32		wpde_next_u;	
	u_int32		wpde_next_l;	

#endif /* __LP64__ */
} whpde2_0_t;

/* Macros/Defines for variable sized pages */
#define PGSHIFT_4K PGSHIFT
#define NBPG_4K	4096

/* Flags to pdapage()/pdarange() */
#define PDE_SB_PREDICT	0x1	/* mark pde as static branch prediction */

#endif /* LOCORE */


#define PDE2_0_RTRAP_POS    2
#define PDE2_0_DIRTY_POS    3
#define PDE2_0_EXECUTED_POS	20
#define PDE2_0_REF_POS		21
#define PDE2_0_ACCESSED_POS	22
#define PDE2_0_MODIFIED_POS 23
#define PDE2_0_BLOCK_MAPPED	19
#define PDE2_0_REF_TRICKLE_POS	18
#define PDE2_0_VAR_PAGE_POS	31

#define PDE2_0_VTAG	0
#define PDE2_0_VTAG_HI	0
#define PDE2_0_VTAG_LO	4
#define PDE2_0_PROT	8
#define PDE2_0_PROT_HI	8
#define PDE2_0_PROT_LO	12
#define PDE2_0_PPN	16
#define PDE2_0_PPN_HI	16
#define PDE2_0_PPN_LO	20
#define PDE2_0_UIP_BYTE	11
#define PDE2_0_UIP_BIT	63
#define PDE2_0_UIP_WBIT	31

#ifdef __LP64__
#define PDE2_0_NEXT	24
#else
#define PDE2_0_NEXT	28
#endif

/* High-word IO space position.  If we do an extract of four bits from
 * this position, and the value found is 0xF, the virtual address maps
 * to an I/O space address.
 */
#define HW2_0_IOSPACE_POS	10

#endif	/* ! _PDE_INCLUDED */
