/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/svc/pfail.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/pfail.h
 *	/usr/conf/pa/pfail.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef _PFAIL_H_INCLUDED
#define _PFAIL_H_INCLUDED

/*
 * Defines needed by powerfail code.
 */
#define PFAIL_VECTOR	0x00000004	/* Absolute memory location 4!! */

/*
 *  Allowed values for pf_subsystem_flag.
 */
#define PF_DISABLED  0
#define PF_ENABLED   1
/*
 *  Allowed values for pf_state (in mpproc_info[].pf_info).
 */
#define PF_SAVESTATE            0
#define PF_PFR_SAVESTATE        1
#define PF_LOCAL_PD             3
#define PF_REMOTE_PD            4
#define PF_RECOVERY             6

/* Allowed values for exit_state (in mpproc_info[].pf_info).  */
#define PF_NOT_STARTED		0
#define PF_PRE_RECOVERY		1
#define PF_DOING_RECOVERY	2
#define PF_CLOCK_SYNC		3
#define PF_READY_TO_EXIT	4
#define PF_ALL_DONE		5

/* Allowed values for soft power switch */
#define	SWITCH_OFF		0
#define	SWITCH_ON		1
#define	SWITCH_UNKNOWN		2


#ifndef	PEPSI_CCC_BUG_FIXED



/*
 * KEYWORDS: HARDWARE SPECIFIC BUG / EMERALD 890 / PEPSI / POWER-FAIL
 * This is for a PEPSI-specific defect on multi-processor systems where a
 * processor in a tight fdce loop can starve out cache coherency operations
 * on the bus.  Serialization of cache flushing (a possible effect of this
 * defect may cause the power-down budget to be exceeded.  The PEPSI chip
 * only present on model 9000/890 machines as of release/9.0.  There are
 * plans to use this chip in future products without fixing this defect
 * (07/17/92).
 *
 * When this hardware bug is fixed or the related products are obsoleted
 * this kludge may be removed by running the related files through 
 * "unifdef -DPEPSI_CCC_BUG_FIXED"
 */
#define PF_READY_TO_FLUSH       6
#endif	/* !PEPSI_CCC_BUG_FIXED */

/* (Mask) values for pf_stat_flag; they should only be set by the monarch.
 * All other processors can read the variable and check the masks.
 */
#define PF_STAT_CLEAR	0x00000000
#define PF_ACTIVE_MASK	0x00000001



#define	FAIL_MASK	0x02000000	/* FAIL bit in cio channel status reg */
#define	LOST_MASK	0x01000000	/* LOST bit in cio channel status reg */
#define IO_EXP_POLL_FRQ		(8 * hz)


#define RENDEZVOUS_INT 0

/* 
 * Powerfail states used for rendezvousing processors
 */

#define   RS_INACTIVE 0
#define   RS_RENDEZ_IN_PROGRESS 1
#define   RS_RENDEZ_ACK 2
#define   RS_PF_ABORTED 3 


#define DISABLE_DMA_CNTR	(&lpd_dma_cntr)
#define WRITE_PF_VECTOR_CNTR	(&lpd_write_cntr)
#define REMOTE_PF_INT	REMOTE_PFAIL_INT_BIT
#define EIRR_REMOTE_PF	REMOTE_PFAIL_INT_ENABLE
#define EIRR_KERN_PFR 	KERN_PFR_INT_ENABLE

#ifndef LOCORE
#ifdef _KERNEL

#include <sys/types.h>

extern struct label_t pfail_save_block[];
extern int pfail_work __((void));
extern void pfail_enable_power_switch __((void));
extern int pfail_power_switch_status __((void));
extern void pf_init __((void));

extern void turn_off_power __((int force_reboot));
extern void pf_shutdown __((void));
extern int pf_active __((void));
extern int local_pf_active __((void));
extern int int_pfail __((int int_bit, struct save_state *ssp));
extern int proc_in_pfr __((int proc_index));

#endif /* _KERNEL */
#endif /* LOCORE */

#endif /* _PFAIL_H_INCLUDED */
