/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/perf/prf.h		$Revision: $
 * 
 *  Purpose:
 *      Defines for the (optional) gprof driver 'prf'
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/prf.h
 *	/usr/conf/pa/prf.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif

/* 'prf_flags' ranges over these */
#define PRF_OPEN	1
#define PRF_NOMEM	2

/* 'profiling' ranges over these */
#define PROFILING_ON	0
#define PROFILING_OFF	3

/* modes for PRF_ON ioctl, full, flat, or same as before */
#define PRF_ON_SAME    -1		/* compat with pre flat/full code */
#define PRF_ON_FLAT	0		/* prod_fullgprof_enabled = 0 */
#define PRF_ON_FULL	1		/* prod_fullgprof_enabled = 1 */

/* for returning PRF_STATUS containing both on/off and flat/full */
#define PRF_ON_MASK         0x03
#define PRF_GP_MODE_SHIFT      2
#define PRF_GP_MODE_MASK    0x0c
#define PRF_GP_MODE_VALID   0x10
