/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/reg.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/reg.h
 *	/usr/conf/pa/reg.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif

#ifndef _MACHINE_REG_INCLUDED /* allow multiple inclusions */
#define _MACHINE_REG_INCLUDED

/*
 *  General Register Definitions
 */

#define	GR0	0
#define	GR1	1
#define	GR2	2
#define	GR3	3
#define	GR4	4
#define	GR5	5
#define	GR6	6
#define	GR7	7
#define	GR8	8
#define	GR9	9
#define	GR10	10
#define	GR11	11
#define	GR12	12
#define	GR13	13
#define	GR14	14
#define	GR15	15
#define	GR16	16
#define	GR17	17
#define	GR18	18
#define	GR19	19
#define	GR20	20
#define	GR21	21
#define	GR22	22
#define	GR23	23
#define	GR24	24
#define	GR25	25
#define	GR26	26
#define	GR27	27
#define	GR28	28
#define	GR29	29
#define	GR30	30
#define	GR31	31

/*
 * Aliases for General Registers
 */

#define	R0	GR0
#define	R1	GR1
#define	R2	GR2
#define	R3	GR3
#define	R4	GR4
#define	R5	GR5
#define	R6	GR6
#define	R7	GR7
#define	R8	GR8
#define	R9	GR9
#define	R10	GR10
#define	R11	GR11
#define	R12	GR12
#define	R13	GR13
#define	R14	GR14
#define	R15	GR15
#define	R16	GR16
#define	R17	GR17
#define	R18	GR18
#define	R19	GR19
#define	R20	GR20
#define	R21	GR21
#define	R22	GR22
#define	R23	GR23
#define	R24	GR24
#define	R25	GR25
#define	R26	GR26
#define	R27	GR27
#define	R28	GR28
#define	R29	GR29
#define	R30	GR30
#define	R31	GR31

/*
 * General Register Conventions
 */

#ifdef __LP64__
#define	GR_ARG7	GR19	/* Eighth Argument */
#define	GR_ARG6	GR20	/* Seventh Argument */
#define	GR_ARG5	GR21	/* Sixth Argument */
#define	GR_ARG4	GR22	/* Fifth Argument */
#endif /* LP64__ */
#define	GR_ARG3	GR23	/* Fourth Argument */
#define	GR_ARG2	GR24	/* Third Argument */
#define	GR_ARG1	GR25	/* Second Argument */
#define	GR_ARG0	GR26	/* First Argument */
#define	GR_DP	GR27	/* Data Pointer */
#ifdef __LP64__
#define	GR_GP	GR27	/* Global Pointer */
#endif /* LP64__ */
#define	GR_FP	GR28	/* Frame Pointer */
#define	GR_AP	GR29	/* Argument Pointer */
#define	GR_SP	GR30	/* Stack Pointer */
#define	GR_PC	GR31	/* Return Program Counter */

/*
 *  Space Register Definitions
 */

#define	SR0	0
#define	SR1	1
#define	SR2	2
#define	SR3	3
#define	SR4	4
#define	SR5	5
#define	SR6	6
#define	SR7	7

/*
 *  Control Register Definitions
 */

/* termio.h also defines a different CR0 */
#ifdef CR0
#undef CR0
#endif
#define	CR0	0
#define	CR8	8
#define	CR9	9
#define	CR10	10
#define	CR11	11
#define	CR12	12
#define	CR13	13
#define	CR14	14
#define	CR15	15
#define	CR16	16
#define	CR17	17
#define	CR18	18
#define	CR19	19
#define	CR20	20
#define	CR21	21
#define	CR22	22
#define	CR23	23
#define	CR24	24
#define	CR25	25
#define	CR26	26
#define	CR27	27
#define	CR28	28
#define	CR29	29
#define	CR30	30
#define	CR31	31

#define	CR_RC	CR0	/* Recovery Counter */
#define	CR_PID1	CR8	/* Protection ID 1 */
#define	CR_PID2	CR9	/* Protection ID 2 */
#define	CR_CCR	CR10	/* Coprocessor Configuration Register */
#define	CR_SAR	CR11	/* Shift Amount Register */
#define	CR_PID3	CR12	/* Protection ID 3 */
#define	CR_PID4	CR13	/* Protection ID 4 */
#define	CR_IVA	CR14	/* Interruption Vector Address */
#define	CR_EIEM	CR15	/* External Interrupt Enable Mask */
#define	CR_IT	CR16	/* Interval Timer */
#define	CR_PCSQ	CR17	/* PC Space Queue */
#define	CR_PCOQ	CR18	/* PC Offset Queue */
#define	CR_IIR	CR19	/* Interruption Instruction Register */
#define	CR_ISR	CR20	/* Interruption Space Register */
#define	CR_IOR	CR21	/* Interruption Offset Register */
#define	CR_IPSW	CR22	/* Interruption Processor Status Word */
#define	CR_EIRR	CR23	/* External Interrupt Request Register */
#define CR_PPDP CR24	/* Per Processor Data Pointer */
#define	CR_PDIR	CR24	/* Physical Page Directory Address Register */
#define	CR_HTBL	CR25	/* Hash Table Address Register */
#define CR_TR2	CR26	/* Temporary Register 2 */
#define CR_TR3	CR27	/* Temporary Register 3 */
#define CR_TLSP CR27	/* Tread Local Storage Register */
#define CR_TR4	CR28	/* Temporary Register 4 */
#define CR_TR5	CR29	/* Temporary Register 5 */
#define CR_TR6	CR30	/* Temporary Register 6 */
#define CR_TR7	CR31	/* Temporary Register 7 */

#define	CCR_MASK	0xff	/* valid bits in coprocessor config reg */
#define	PID_MASK	0xffff	/* valid bits in prot id reg */

/*
 * protection id register layout for 2.0
 *
 *   |----------|------------|
 *   |  Pid5    |   Pid1     |  CR8
 *   |----------|------------|
 *   |  Pid6    |   Pid2     |  CR9
 *   |----------|------------|
 *   |  Pid7    |   Pid3     |  CR11
 *   |----------|------------|
 *   |  Pid8    |   Pid4     |  CR12
 *   |----------|------------|
 * 
 * the following defines make it easier
 * to visualize and use the software
 * convention described above.
 * These defines are for checkprotid(),
 * insqRprot(), insqWprot, and delqprot().
 * which access the protection ids as an
 * array of integers rather than 4 double
 * word registers.
 */

#define	PID1	1
#define	PID2	3
#define	PID3	5
#define	PID4	7
#define	PID5	0
#define	PID6	2
#define	PID7	4
#define	PID8	6
#define	PA_2_0_PIDS	8
#define	RANDOM_INSERT_MASK	0x1C


/*
 * The shift amount register has 6 valid bits for the PA2.0 architecture,
 * to allow manipulation of 64-bit general registers.  It only has 5 valid
 * bits for PA1.0 and PA1.1 architectures.
 */
#ifndef __LP64__
#define	SAR_MASK	0x1f	/* valid bits in shift amount reg (PA1.x) */
#else /* __LP64__ */
#define	SAR_MASK	0x3f	/* valid bits in shift amount reg (PA2.0) */
#endif /* __LP64__ */
#define	SAR_MASK32	0x1f	/* valid bits in shift amount reg (PA1.x) */
#define	SAR_MASK64	0x3f	/* valid bits in shift amount reg (PA2.0) */

#define	FP0	0	/* Floating Point Registers */
#define	FP1	1
#define	FP2	2
#define	FP3	3
#define	FP4	4
#define	FP5	5
#define	FP6	6
#define	FP7	7
#define	FP8	8
#define	FP9	9
#define	FP10	10
#define	FP11	11
#define	FP12	12
#define	FP13	13
#define	FP14	14
#define	FP15	15

#endif /* _MACHINE_REG_INCLUDED */
