/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/sys/rpb.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/rpb.h
 *	/usr/conf/pa/rpb.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef _MACHINE_RPB_INCLUDED
#define _MACHINE_RPB_INCLUDED

#ifdef	__hp9000s800

/*
 * The restart parameter block, which is a page in (very) low
 * core which runs after a crash.  Currently, the restart
 * procedure takes a dump.
 */

typedef struct pim_narrow {
	uint32_t rp_gr0;		/* General Registers */
	uint32_t rp_gr1;
	uint32_t rp_rp;
	uint32_t rp_gr3;
	uint32_t rp_gr4;
	uint32_t rp_gr5;
	uint32_t rp_gr6;
	uint32_t rp_gr7;
	uint32_t rp_gr8;
	uint32_t rp_gr9;
	uint32_t rp_gr10;
	uint32_t rp_gr11;
	uint32_t rp_gr12;
	uint32_t rp_gr13;
	uint32_t rp_gr14;
	uint32_t rp_gr15;
	uint32_t rp_gr16;
	uint32_t rp_gr17;
	uint32_t rp_gr18;
	uint32_t rp_gr19;
	uint32_t rp_gr20;
	uint32_t rp_gr21;
	uint32_t rp_gr22;
	uint32_t rp_arg3;
	uint32_t rp_arg2;
	uint32_t rp_arg1;
	uint32_t rp_arg0;
	uint32_t rp_dp;
	uint32_t rp_ret0;
	uint32_t rp_ret1;
	uint32_t rp_sp;
	uint32_t rp_gr31;
	uint32_t rp_cr0;		/* Control Registers */
	uint32_t rp_cr1;
	uint32_t rp_cr2;
	uint32_t rp_cr3;
	uint32_t rp_cr4;
	uint32_t rp_cr5;
	uint32_t rp_cr6;
	uint32_t rp_cr7;
	uint32_t rp_cr8;
	uint32_t rp_cr9;
	uint32_t rp_cr10;
	uint32_t rp_cr11;
	uint32_t rp_cr12;
	uint32_t rp_cr13;
	uint32_t rp_cr14;
	uint32_t rp_cr15;
	uint32_t rp_cr16;
	uint32_t rp_pcsq_head;
	uint32_t rp_pcoq_head;
	uint32_t rp_cr19;		/* For break and assist traps only */
	uint32_t rp_cr20;		/* For data page fault only */
	uint32_t rp_cr21;
	uint32_t rp_cr22;
	uint32_t rp_cr23;
	uint32_t rp_cr24;
	uint32_t rp_cr25;
	uint32_t rp_cr26;
	uint32_t rp_cr27;
	uint32_t rp_cr28;
	uint32_t rp_cr29;
	uint32_t rp_cr30;
	uint32_t rp_cr31;
	uint32_t rp_sr0;
	uint32_t rp_sr1;
	uint32_t rp_sr2;
	uint32_t rp_sr3;
	uint32_t rp_sr4;
	uint32_t rp_sr5;
	uint32_t rp_sr6;
	uint32_t rp_sr7;
	uint32_t rp_pcsq_tail;
	uint32_t rp_pcoq_tail;

	uint32_t rp_hpmc_type;
	uint32_t rp_hpmc_cpu_state;
	uint32_t rp_hpmc_detected_by;
	uint32_t rp_hpmc_cache;
	uint32_t rp_hpmc_tlb;
	uint32_t rp_hpmc_bus;
	uint32_t rp_hpmc_assists;
	uint32_t rp_hpmc_processor;
	uint32_t rp_hpmc_assist_id;
	uint32_t rp_hpmc_slave_addr;
	uint32_t rp_hpmc_master_addr;

	uint32_t rp_hversion_depend[40];	/* HV dependent pim info */
} pim_narrow_t;

typedef struct pim_wide {
	uint32_t rp_gr0_hi;		/* General Registers */
	uint32_t rp_gr0_low;			
	uint32_t rp_gr1_hi;
	uint32_t rp_gr1_low;
	uint32_t rp_rp_hi;
	uint32_t rp_rp_low;
	uint32_t rp_gr3_hi;
	uint32_t rp_gr3_low;
	uint32_t rp_gr4_hi;
	uint32_t rp_gr4_low;
	uint32_t rp_gr5_hi;
	uint32_t rp_gr5_low;
	uint32_t rp_gr6_hi;
	uint32_t rp_gr6_low;
	uint32_t rp_gr7_hi;
	uint32_t rp_gr7_low;
	uint32_t rp_gr8_hi;
	uint32_t rp_gr8_low;
	uint32_t rp_gr9_hi;
	uint32_t rp_gr9_low;
	uint32_t rp_gr10_hi;
	uint32_t rp_gr10_low;
	uint32_t rp_gr11_hi;
	uint32_t rp_gr11_low;
	uint32_t rp_gr12_hi;
	uint32_t rp_gr12_low;
	uint32_t rp_gr13_hi;
	uint32_t rp_gr13_low;
	uint32_t rp_gr14_hi;
	uint32_t rp_gr14_low;
	uint32_t rp_gr15_hi;
	uint32_t rp_gr15_low;
	uint32_t rp_gr16_hi;
	uint32_t rp_gr16_low;
	uint32_t rp_gr17_hi;
	uint32_t rp_gr17_low;
	uint32_t rp_gr18_hi;
	uint32_t rp_gr18_low;
	uint32_t rp_gr19_hi;
	uint32_t rp_gr19_low;
	uint32_t rp_gr20_hi;
	uint32_t rp_gr20_low;
	uint32_t rp_gr21_hi;
	uint32_t rp_gr21_low;
	uint32_t rp_gr22_hi;
	uint32_t rp_gr22_low;
	uint32_t rp_arg3_hi;
	uint32_t rp_arg3_low;
	uint32_t rp_arg2_hi;
	uint32_t rp_arg2_low;
	uint32_t rp_arg1_hi;
	uint32_t rp_arg1_low;
	uint32_t rp_arg0_hi;
	uint32_t rp_arg0_low;
	uint32_t rp_dp_hi;
	uint32_t rp_dp_low;
	uint32_t rp_ret0_hi;
	uint32_t rp_ret0_low;
	uint32_t rp_ret1_hi;
	uint32_t rp_ret1_low;
	uint32_t rp_sp_hi;
	uint32_t rp_sp_low;
	uint32_t rp_gr31_hi;
	uint32_t rp_gr31_low;
	uint32_t rp_cr0_hi;		/* Control Registers */
	uint32_t rp_cr0_low;
	uint32_t rp_cr1_hi;
	uint32_t rp_cr1_low;
	uint32_t rp_cr2_hi;
	uint32_t rp_cr2_low;
	uint32_t rp_cr3_hi;
	uint32_t rp_cr3_low;
	uint32_t rp_cr4_hi;
	uint32_t rp_cr4_low;
	uint32_t rp_cr5_hi;
	uint32_t rp_cr5_low;
	uint32_t rp_cr6_hi;
	uint32_t rp_cr6_low;
	uint32_t rp_cr7_hi;
	uint32_t rp_cr7_low;
	uint32_t rp_cr8_hi;
	uint32_t rp_cr8_low;
	uint32_t rp_cr9_hi;
	uint32_t rp_cr9_low;
	uint32_t rp_cr10_hi;
	uint32_t rp_cr10_low;
	uint32_t rp_cr11_hi;
	uint32_t rp_cr11_low;
	uint32_t rp_cr12_hi;
	uint32_t rp_cr12_low;
	uint32_t rp_cr13_hi;
	uint32_t rp_cr13_low;
	uint32_t rp_cr14_hi;
	uint32_t rp_cr14_low;
	uint32_t rp_cr15_hi;
	uint32_t rp_cr15_low;
	uint32_t rp_cr16_hi;
	uint32_t rp_cr16_low;
	uint32_t rp_pcsq_head_hi;
	uint32_t rp_pcsq_head_low;
	uint32_t rp_pcoq_head_hi;
	uint32_t rp_pcoq_head_low;
	uint32_t rp_cr19_hi;		/* For break and assist traps only */
	uint32_t rp_cr19_low;		/* For break and assist traps only */
	uint32_t rp_cr20_hi;		/* For data page fault only */
	uint32_t rp_cr20_low;		/* For data page fault only */
	uint32_t rp_cr21_hi;
	uint32_t rp_cr21_low;
	uint32_t rp_cr22_hi;
	uint32_t rp_cr22_low;
	uint32_t rp_cr23_hi;
	uint32_t rp_cr23_low;
	uint32_t rp_cr24_hi;
	uint32_t rp_cr24_low;
	uint32_t rp_cr25_hi;
	uint32_t rp_cr25_low;
	uint32_t rp_cr26_hi;
	uint32_t rp_cr26_low;
	uint32_t rp_cr27_hi;
	uint32_t rp_cr27_low;
	uint32_t rp_cr28_hi;
	uint32_t rp_cr28_low;
	uint32_t rp_cr29_hi;
	uint32_t rp_cr29_low;
	uint32_t rp_cr30_hi;
	uint32_t rp_cr30_low;
	uint32_t rp_cr31_hi;
	uint32_t rp_cr31_low;
	uint32_t rp_sr0_hi;
	uint32_t rp_sr0_low;
	uint32_t rp_sr1_hi;
	uint32_t rp_sr1_low;
	uint32_t rp_sr2_hi;
	uint32_t rp_sr2_low;
	uint32_t rp_sr3_hi;
	uint32_t rp_sr3_low;
	uint32_t rp_sr4_hi;
	uint32_t rp_sr4_low;
	uint32_t rp_sr5_hi;
	uint32_t rp_sr5_low;
	uint32_t rp_sr6_hi;
	uint32_t rp_sr6_low;
	uint32_t rp_sr7_hi;
	uint32_t rp_sr7_low;
	uint32_t rp_pcsq_tail_hi;
	uint32_t rp_pcsq_tail_low;
	uint32_t rp_pcoq_tail_hi;
	uint32_t rp_pcoq_tail_low;

	uint32_t rp_hpmc_type;
	uint32_t rp_hpmc_cpu_state;
	uint32_t rp_hpmc_cache;
	uint32_t rp_hpmc_tlb;
	uint32_t rp_hpmc_bus;
	uint32_t rp_hpmc_assists;
	uint32_t rp_hpmc_assist_id;
	uint32_t rp_path_info;
	uint32_t rp_hpmc_slave_addr_hi;
	uint32_t rp_hpmc_slave_addr;
	uint32_t rp_hpmc_master_addr_hi;
	uint32_t rp_hpmc_master_addr;

	uint32_t rp_hversion_depend[40];	/* HV dependent pim info */
} pim_wide_t;

typedef struct rpb {
	char    *sp;			/* Saved sp */
	long     rp_flag;		/* Avoid dumping more than once */
	union pim_info {		/* Must be doubleword aligned */
	    pim_narrow_t narrow;	/* PA1.x pim info */
	    pim_wide_t   wide;		/* PA2.0 pim info */
	} pim; 
	uint32_t rp_itimer_hi; 		/* Interval timer on entry of crash */
	uint32_t rp_itimer_low;		/*    (_hi field not used for 1.x)  */
	ulong_t  rp_time;		/* time seconds at time of crash */
	ulong_t  rp_time2;		/* time usecs at time of crash */
	ulong_t  rp_proc_hpa; 		/* Processor HPA value (sanity check) */
	uint32_t rp_crash_type;		/* Type: CT_PANIC, CT_HPMC, or CT_TOC */
	long     rp_pim_return;		/* Return value from PDC_PIM */
	uint32_t rp_global_psw;		/* "global_psw" at time of crash */
	uint32_t rp_nothread;		/* "nothread" at time of crash */
	long     end_align;		/* THIS MUST BE THE LAST ELEMENT!! */
} rpb_t;


#endif	/* __hp9000s800 */

#endif /* not _MACHINE_RPB_INCLUDED */
