/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/scall/scall_defs.h		$Revision: $
 * 
 *  Purpose:
 *	The most basic syscall-related defines.
 *
 *	IMPORTANT:
 *	  This file is included by both C and assembly files, so don't put
 *	  anything in here that both the C compiler and assembler can't
 *	  handle.
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/scall_defs.h
 *	/usr/conf/pa/scall_defs.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


/*
 * The PA 1.0 procedure calling convention only uses gr's 26 through 23
 * to pass arguments, so the system call number was passed to the kenrel
 * by the libc stub through gr22.
 *
 * The PA 2.0 procedure calling convention uses gr's 26 through 19, so
 * the libc stub will see arg4 in gr22 on entry.
 *
 * To keep the kernel interface uniform the stubs continue to pass the
 * system call number through gr22.  As a result, the stub must move
 * arg4 (only if the call has a fifth argument) to another register
 * before loading gr22 with the system call number.
 *
 * IMPORTANT:
 *	Don't change this register once archive-bound 64-bit programs
 *	have been created unless you are prepared to deal with the
 *	resulting backward-compatibility problems.
 */

#define	SYS_ARG4	r28

/*
 * The number of 32-bit lightweights supported at any given time depends
 * on how many gateway pages have been set aside for them.
 *
 * Each 32-bit gateway page can hold at most 256 entries.  The first
 * such page can hold at most 253.  The last page loses the last entry
 * to the security fixup, so it can hold at most 255 entries.  If there
 * is only one page, it is both first and last, so it can hold at most
 * 252 entries.
 *
 * This constant is used to generate the gateway entries and to do the
 * range check at the top of the first gateway page.
 */

#define	LW_MAXNUM	252

/*
 * There is a fixed maximum number of arguments that system calls can
 * handle.  This number can easily be raised for any release by
 * increasing this constant.
 */

#define	SCALL_MAXARGS	10
