/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/svc/trap.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  no
 *
 *  Shipped:  yes
 *	/usr/include/pa/trap.h
 *	/usr/conf/pa/trap.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif

#ifndef _MACHINE_TRAP_INCLUDED /* allow multiple inclusions */
#define _MACHINE_TRAP_INCLUDED

/*
 * Trap type values
 */

#define I_NONEXIST       0
#define I_HPMACH_CHK     1
#define I_POW_FAIL       2
#define I_RECOV_CTR      3
#define I_EXT_INTP       4
#define I_LPMACH_CHK     5
#define I_IPGFT          6
#define I_IMEM_PROT      7
#define I_UNIMPL_INST    8
#define I_BRK_INST       9
#define I_PRIV_OP        10
#define I_PRIV_REG       11
#define I_OVFLO          12
#define I_COND           13
#define I_EXCEP          14
#define I_DPGFT          15
#define I_IPGFT_NA       16
#define I_DPGFT_NA       17
#define I_DMEM_PROT      18
#define I_DMEM_BREAK     19
#define I_TLB_DIRTY      20
#define I_VIO_REF        21
#define I_EMULAT         22
#define I_HPRIV_XFR      23
#define I_LPRIV_XFR      24
#define I_TAKEN_BR       25

/* The following trap types are not architected; they are software generated.
 * Do not renumber them without adjusting trap_type[] in trap.c
 */
#define T_KPREEMPT       26		/* kernel preemption */
#define I_ICS_OVFL       27		/* interrupt stack overflow */
#define I_KS_OVFL        28		/* kernel stack overflow */
#define T_MPSCHED        29		/* MPSCHED reschedule bit */
#define T_PANIC          31		/* Panic trap */
#define I_UNEXPECT  	 30

#define I_PERF_MON       60    		 /* Really, trap 29. */
/*
 * At this time, the Topgun kludge is present with the SPARSE_PDIR flag
 *  turned on
 */


#define USER    040             /* user-mode flag added to type */

#define PIM_SAVE_STATE_SIZE             296
#define PIM2_0_SAVE_STATE_SIZE          592
#define IO_DIAG_MAX_BUF_LEN 72

/*
 * General Register Reference Macro - ssgr(gr)
 *
 * This macro allows references to arbitrary general
 * registers as found in the save_state structure.  It
 * may be used on either side of an assignment statement.
 * The argument register number must be between 1 and 31
 * inclusive.  If register number is known at compile time
 * ssp->ss_narrow.ss_grX or ssp->ss_wide.ss_64.ss_grX should be used instead.
 */
#define ssgr32(gr)	(* (((int *) &ssp->ss_narrow.ss_gr1) + ((gr)-1)))
#define ssgr64(gr)	(* (((int64_t *)&ssp->ss_wide.ss_64.ss_gr1) + ((gr)-1)))
#ifdef __LP64
#define ssgr(gr)	(ssgr64(gr))
#else
#define ssgr(gr)	(UseWideRegs(ssp) ? ssgr64(gr) : ssgr32(gr))
#endif

#define BIT00		0x80000000
#define BIT01		0x40000000
#define BIT02		0x20000000
#define BIT03		0x10000000
#define BIT04		0x08000000
#define BIT05		0x04000000
#define BIT19		0x00001000
#define BIT22		0x00000200
#define BIT23		0x00000100
#define BIT24		0x00000080
#define BIT25		0x00000040

#define OP_MASK		(BIT00+BIT01+BIT02+BIT03+BIT04+BIT05)
#define SEC_OP_MASK	(BIT19+BIT22+BIT23+BIT24+BIT25)
#define LDB		(BIT01)
#define LDH		(BIT01+BIT05)
#define LDW		(BIT01+BIT04)
#define LDWM		(BIT01+BIT04+BIT05)
#define STW		(BIT01+BIT02+BIT04)
#define STH		(BIT01+BIT02+BIT05)
#define STB		(BIT01+BIT02)
#define STWM		(BIT01+BIT02+BIT04+BIT05)
#define INDEX_SHORT	(BIT04+BIT05)
#define LDBX		(0)
#define LDHX		(BIT25)
#define LDWX		(BIT24)
#define LDBS		(BIT19)
#define LDHS		(BIT19+BIT25)
#define LDWS		(BIT19+BIT24)
#define STBYS		(BIT19+BIT22+BIT23)
#define STWS		(BIT19+BIT22+BIT24)
#define STHS		(BIT19+BIT22+BIT25)
#define STBS		(BIT19+BIT22)
#define MODIFY		(BIT26)

#define sign_ext14(x)	(int)((x)&1 ? (x)>>1 | 0xffffe000 : (x)>>1 & 0x00001fff)
#define sign_ext5(x)	(int)((x)&1 ? (x)>>1 | 0xfffffff0 : (x)>>1 & 0x0000000f)
#define sh_load_disp(x) (int)(sign_ext5( ((x)&0x001f0000)>>16 ))
	
#define MBIT		(0x00000020)
#define UBIT		(0x00002000)
#define TREG_LOAD	(0x001f0000)
#define TREG_X_S	(0x0000001f)
#define BREG		(0x03e00000)
#define XREG		(0x001f0000)
#define treg_load(instr) (((instr)&TREG_LOAD)>>16)
#define treg_x_s(instr) ((instr)&TREG_X_S)
#define breg(instr) (((instr)&BREG)>>21)
#define xreg(instr) (((instr)&XREG)>>16)

#define WORD_RTN 0xffffffff
#define HALF_RTN 0x0000ffff
#define BYTE_RTN 0x000000ff

#endif /* _MACHINE_TRAP_INCLUDED */
