/*
 * BEGIN_DESC
 * 
 *  File: 
 *      @(#)B.11.11_LR	pa/vm/vmtypes.h		$Revision: $
 * 
 *  Purpose:
 *      <<please update with a synopis of the functionality provided by this file>>
 * 
 *  Classification:			Release to Release Consistency Req:
 *		<<please select one of the following:>>
 * 	kernel subsystem private		none
 * 	kernel private				none
 * 	kernel 3rd party private		limited source
 * 	public					binary & source
 * 
 *  BE header:  yes
 *
 *  Shipped:  yes
 *	/usr/include/pa/vmtypes.h
 *	/usr/conf/pa/vmtypes.h
 *
 *  <<please delete the following note if this is a "public" header>>
 *  NOTE:
 *	This header file contains information specific to the internals
 *	of the HP-UX implementation.  The contents of this header file
 *	are subject to change without notice.  Such changes may affect
 *	source code, object code, or binary compatibility between
 *	releases of HP-UX.  Code which uses the symbols contained within
 *	this header file is inherently non-portable (even between HP-UX
 *	implementations).
 * 
 * END_DESC  
*/

#ifdef __NO_PA_HDRS
    PA header file -- do not include this header file for non-PA builds.
#endif


#ifndef _MACHINE_VMTYPES_INCLUDED
#define	_MACHINE_VMTYPES_INCLUDED

   /* For physical memory addresses and/or physical offsets */
   typedef uintptr_t		paddr_t;	/* physical byte address */

   /*
    * For page oriented variables.
    * Note that this should remain a *signed* quantity because some
    * variables (e.g., mem_deficit) need to be signed.
    */
   /*
    * NOTE:
    * page_t will be replaced by pgcnt_t.  Don't add new code which
    * references page_t.
    */
   typedef intptr_t		page_t;		/* XXX will be removed */
   typedef int32_t		pgcnt_t;	/* page counts */
   typedef uint32_t		upgcnt_t;	/* SHOULD BE USED ONLY */
						/* TO PROMOTE pgcnt_t to */
						/* (unsigned long) TO */
						/* SUPPRESS lint warnings */
   typedef uint32_t		physpfn_t;	/* physical page number */
   typedef uintptr_t		iophyspfn_t;	/* IO physical page number */
   typedef uintptr_t		pgaddr_t;	/* address after btop() */

   typedef uint32_t		space_t;
   typedef uint32_t		prot_t;

#endif	/* _MACHINE_VMTYPES_INCLUDED */
